#define BANNER "GL Viewer for Mathematica"
#define VERSION "1.1"
#define TWO_PI (2.0*3.14159265358979324) 
#define PI 3.14159265358979324
#define MaxLSAngle (75.0) 
#define MENU_ID_SAVEPOVRAY_SMOOTH (101) 
#define MENU_ID_SAVEPOVRAY_FLAT (102) 
#define MENU_ID_SAVE_DXF (103)  \
 \

#define MENU_ID_SPIN_X (201) 
#define MENU_ID_SPIN_Y (202) 
#define MENU_ID_SPIN_Z (203) 
#define MENU_ID_SPIN_SLOW (204) 
#define MENU_ID_SPIN_FAST (205) 
#define MENU_ID_SPIN_TRACKBALL (206) 
#define MENU_ID_STOP (207)  \
 \

#define MENU_ID_SHOW_SMOOTH (301) 
#define MENU_ID_SHOW_FLAT (302) 
#define MENU_ID_SHOW_WIRE (303)  \

#define MENU_ID_ABOUT (401) 
#define MENU_ID_RESET (402) 
#define MENU_ID_FLIP_FACE (403) 
#define MENU_ID_ZOOM_IN (404) 
#define MENU_ID_ZOOM_OUT (405) 
#define MENU_ID_CLEAR (406) 
#define MENU_ID_QUIT (666)  \

#define Line3D (1) 
#define Polygon3D (2) 
#define INIT_POOLSIZE 8192
#define POOL_INC 1024
#define TINY (0.1e-9) 
#define MAX_LIGHT (8) 
#define sign(a) (a>0.0?1.:-1.)  \

#define sqr(a) ((a) *(a) ) 
#define IncPoint3D(p,inc) {p.x+= inc.x;p.y+= inc.y;p.z+= inc.z;}
#define AddPoint3D(res,a,b) {res.x= a.x+b.x;res.y= a.y+b.y;res.z= a.z+b.z;} \

#define MAX_STRING (256) 
#define ToDegree (180.0/3.1415926) 
#define ToRadian (3.1415926/180.0) 
#define MVNearPlane (1.0) 
#define MVFarPlane (10.0) 
#define MVViewAngle (45.0)  \

#define MAX(a,b) (a>b?a:b) 
#define PointSphereSegmentsPhi 18
#define PointSphereSegmentsTheta 9
#define Camera 2.33
#define POLY_LAYER 1
#define LINE_LAYER 2
#define POINT_LAYER 3 \

#define MLPutList(n) MLPutFunction(stdlink,"List",n) 
/*1:*/
#line 8 "F:\Develop\mview3d\mathview3d.w"

#ifdef __WIN32__
#  define ARCH "Win32 with OpenGL"
#elif !defined(ARCH)
#  define ARCH "Solaris 2.51 with OpenGL"
#endif
/*235:*/
#line 3618 "F:\Develop\mview3d\mathview3d.w"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <GL/glut.h>
#include <mathlink.h>
#include <cmdln.h>
#if defined(__WIN32__) && defined(__BORLANDC__)
#  include <float.h>
#else
# include <unistd.h>
#endif/*:235*/
#line 14 "F:\Develop\mview3d\mathview3d.w"

#ifndef MAX
#  define MAX(a,b) ((a)>(b) ? (a) : (b))
#endif
#ifndef MIN
#  define MIN(a,b) ((a)<(b) ? (a) : (b))
#endif
#define MAX3(a,b,c) ((a)>(b) ? MAX(a,c) : MAX(b,c))

/*36:*/
#line 607 "F:\Develop\mview3d\mathview3d.w"

/*37:*/
#line 613 "F:\Develop\mview3d\mathview3d.w"

typedef struct Point3D{double x,y,z;}Point3D;

/*:37*/
#line 608 "F:\Develop\mview3d\mathview3d.w"

/*41:*/
#line 638 "F:\Develop\mview3d\mathview3d.w"

typedef struct RGBColor{double r,g,b;}RGBColor;

/*:41*/
#line 609 "F:\Develop\mview3d\mathview3d.w"

/*42:*/
#line 641 "F:\Develop\mview3d\mathview3d.w"

typedef struct PointList{
RGBColor color;
double size;
int point;
struct PointList*next;
}PointList;

/*:42*/
#line 610 "F:\Develop\mview3d\mathview3d.w"

/*48:*/
#line 702 "F:\Develop\mview3d\mathview3d.w"

typedef struct LinePolyList{
short int what;
RGBColor color;
int aux1;
double aux2;
int*points;
int pno;
struct LinePolyList*next;
}LinePolyList;

/*:48*/
#line 611 "F:\Develop\mview3d\mathview3d.w"


/*:36*/
#line 23 "F:\Develop\mview3d\mathview3d.w"

void CreateObject(void);
/*13:*/
#line 236 "F:\Develop\mview3d\mathview3d.w"

char ThreeScriptName[256]= "";
int SmoothShading= 0;
int WireFrame= GL_FALSE;
int PolyOutline= GL_FALSE;
int COMTriangulation= GL_FALSE;
Point3D ZoomMove= {0.,0.,0.};
Point3D CenterOfScene= {0.0,0.0,0.0};
Point3D ScaleOfScene= {1.0,1.0,1.0};
double MaxScaleOfScene= 1.0;
int MakeNewView= GL_FALSE;
double RadialZoom= 1.0;

/*:13*//*14:*/
#line 250 "F:\Develop\mview3d\mathview3d.w"

char POVOutName[256]= "";
char DXFOutName[256]= "";
int NoDisplay= GL_FALSE;

/*:14*//*15:*/
#line 263 "F:\Develop\mview3d\mathview3d.w"

double LineTubeSize= 0.0;
int TubeSegments= 12;
double LineSegmentAngle= 30.;
double CosSkipCont;
double PointSphereSize= 0.0;
const RGBColor Black= {0.0,0.0,0.0};
const RGBColor White= {1.0,1.0,1.0};
Point3D XAxis= {1.0,0.0,0.0};
Point3D YAxis= {0.0,1.0,0.0};
Point3D ZAxis= {0.0,0.0,1.0};

/*:15*//*16:*/
#line 275 "F:\Develop\mview3d\mathview3d.w"

int MakeNewModel= GL_FALSE;
int DoReset= GL_FALSE;
int DoTracking= GL_FALSE;
int DoTrackSpin= GL_FALSE;
int GetMouseTrack= GL_TRUE;
int ScreenX,ScreenY;
int ScreenXStart,ScreenYStart;
Point3D TrackAxis;
double TrackAngle,DTrackAngle;
int ScreenWidth,ScreenHeight;

/*:16*//*17:*/
#line 315 "F:\Develop\mview3d\mathview3d.w"

int menuIDMain;
int menuIDFiles;
int menuIDSpin;
int menuIDAppear;

/*:17*//*38:*/
#line 620 "F:\Develop\mview3d\mathview3d.w"

Point3D*PointPool= NULL;
Point3D**NormalPool= NULL;
int PoolSize= 0;
int MaxPoolSize= 0;

/*:38*//*63:*/
#line 932 "F:\Develop\mview3d\mathview3d.w"

PointList*Points= NULL;
LinePolyList*Lines= NULL;
LinePolyList*Polygons= NULL;

/*:63*//*68:*/
#line 997 "F:\Develop\mview3d\mathview3d.w"

Point3D ViewPoint;
RGBColor AmbientColor;
Point3D BoundP1,BoundP2;
Point3D LightPosition[MAX_LIGHT];
RGBColor LightColor[MAX_LIGHT];
int LightNo= 0;
int PolygonEdge= 1;

/*:68*//*101:*/
#line 1531 "F:\Develop\mview3d\mathview3d.w"

int ObjID= -1;




/*:101*//*229:*/
#line 3545 "F:\Develop\mview3d\mathview3d.w"

MLINK LinkToMath;
int MathLinkMode= GL_FALSE;
int MathLinkActive= GL_FALSE;

/*:229*/
#line 25 "F:\Develop\mview3d\mathview3d.w"

/*64:*/
#line 941 "F:\Develop\mview3d\mathview3d.w"

int AddToPointPool(double x,double y,double z);
/*:64*//*198:*/
#line 3092 "F:\Develop\mview3d\mathview3d.w"

void mvClearContents(void);

/*:198*//*208:*/
#line 3204 "F:\Develop\mview3d\mathview3d.w"

void mlWritePOVray(const char*,int,double,int,double,double);

/*:208*//*232:*/
#line 3579 "F:\Develop\mview3d\mathview3d.w"

int ProcessMathLink(MLINK*mlp);

/*:232*/
#line 26 "F:\Develop\mview3d\mathview3d.w"

/*69:*/
#line 1007 "F:\Develop\mview3d\mathview3d.w"

/*70:*/
#line 1018 "F:\Develop\mview3d\mathview3d.w"

double Dot(Point3D*p1,Point3D*p2)
{
return p1->x*p2->x+p1->y*p2->y+p1->z*p2->z;
}

/*:70*/
#line 1008 "F:\Develop\mview3d\mathview3d.w"

/*71:*/
#line 1024 "F:\Develop\mview3d\mathview3d.w"

void Cross(Point3D*c,Point3D*a,Point3D*b)
{
c->x= -a->z*b->y+a->y*b->z;
c->y= a->z*b->x-a->x*b->z;
c->z= -a->y*b->x+a->x*b->y;
}

/*:71*/
#line 1009 "F:\Develop\mview3d\mathview3d.w"

/*72:*/
#line 1032 "F:\Develop\mview3d\mathview3d.w"

double Norm(Point3D*p)
{
return sqrt(Dot(p,p));
}

/*:72*/
#line 1010 "F:\Develop\mview3d\mathview3d.w"

/*74:*/
#line 1062 "F:\Develop\mview3d\mathview3d.w"

void SphericalFromCartesian(Point3D*p,
double*r,double*theta,double*phi)
{
*r= Norm(p);
if(p->x!=0.0&&p->y!=0.0)
*phi= atan2(p->y,p->x);
else
*phi= 0.0;
if(*r==0.0)
*theta= 0.0;
else
*theta= acos(p->z/(*r));
}

/*:74*/
#line 1011 "F:\Develop\mview3d\mathview3d.w"

/*75:*/
#line 1077 "F:\Develop\mview3d\mathview3d.w"

void CartesianFromSpherical(double r,double theta,double phi,
Point3D*p)
{double st;

st= r*sin(theta);
p->x= cos(phi)*st;
p->y= sin(phi)*st;
p->z= r*cos(theta);
}


/*:75*/
#line 1012 "F:\Develop\mview3d\mathview3d.w"

/*73:*/
#line 1038 "F:\Develop\mview3d\mathview3d.w"

int SurfaceNormal(Point3D*nrm,
Point3D*p1,Point3D*p2,Point3D*p3)
{Point3D v1,v2;
double n;

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;
v2.x= p3->x-p2->x;
v2.y= p3->y-p2->y;
v2.z= p3->z-p2->z;
Cross(nrm,&v1,&v2);
n= Norm(nrm);
if(n!=0.0){
nrm->x/= n;
nrm->y/= n;
nrm->z/= n;
return GL_TRUE;
}
return GL_FALSE;

}

/*:73*/
#line 1013 "F:\Develop\mview3d\mathview3d.w"

/*76:*/
#line 1093 "F:\Develop\mview3d\mathview3d.w"

void OrthogonalSet(Point3D*v1,Point3D*v2,Point3D*v3)
{double a,b,c,n,*p;
int i;

a= v1->x;b= v1->y;c= v1->z;
p= (double*)v1;
i= 0;
if(fabs(p[i])<fabs(p[1]))i= 1;
if(fabs(p[i])<fabs(p[2]))i= 2;
switch(i){
case 0:
/*78:*/
#line 1128 "F:\Develop\mview3d\mathview3d.w"

n= sqrt(a*a+c*c);
if(n>0.0){
v2->x= -a*b/n,
v2->y= n;
v2->z= -b*c/n;

v3->x= -c*sign(a)/n;
v3->y= 0;
v3->z= fabs(a)/n;
}

/*:78*/
#line 1105 "F:\Develop\mview3d\mathview3d.w"

break;
case 1:
/*79:*/
#line 1140 "F:\Develop\mview3d\mathview3d.w"

n= sqrt(b*b+c*c);
if(n>0.0){
v2->x= n;
v2->y= -a*b/n;
v2->z= -a*c/n;

v3->x= 0.0;
v3->y= -c*sign(b)/n;
v3->z= fabs(b)/n;
}

/*:79*/
#line 1108 "F:\Develop\mview3d\mathview3d.w"

break;
case 2:
/*77:*/
#line 1116 "F:\Develop\mview3d\mathview3d.w"

n= sqrt(b*b+c*c);
if(n>0.0){
v2->x= n;
v2->y= -a*b/n;
v2->z= -a*c/n;

v3->x= 0.0;
v3->y= fabs(c)/n;
v3->z= -b*sign(c)/n;
}

/*:77*/
#line 1111 "F:\Develop\mview3d\mathview3d.w"

break;
}
}

/*:76*/
#line 1014 "F:\Develop\mview3d\mathview3d.w"

/*80:*/
#line 1152 "F:\Develop\mview3d\mathview3d.w"

void GramSchmidt(Point3D*e1,Point3D*e2,Point3D*e3)
{double d12,d13,d23,n;

d12= Dot(e1,e2);
e2->x-= d12*e1->x;
e2->y-= d12*e1->y;
e2->z-= d12*e1->z;
n= Norm(e2);
e2->x/= n;e2->y/= n;e2->z/= n;
d13= Dot(e1,e3);
e3->x-= d13*e1->x;
e3->y-= d13*e1->y;
e3->z-= d13*e1->z;
n= Norm(e3);
e3->x/= n;e3->y/= n;e3->z/= n;
d23= Dot(e2,e3);
e3->x-= d23*e2->x;
e3->y-= d23*e2->y;
e3->z-= d23*e2->z;
n= Norm(e3);
e3->x/= n;e3->y/= n;e3->z/= n;
}



/*:80*/
#line 1015 "F:\Develop\mview3d\mathview3d.w"

/*81:*/
#line 1179 "F:\Develop\mview3d\mathview3d.w"

void ConePoint(double r,double phi,Point3D*u,Point3D*v,Point3D*p)
{double cphi,sphi;

cphi= r*cos(phi);
sphi= r*sin(phi);
p->x= (cphi*u->x+sphi*v->x);
p->y= (cphi*u->y+sphi*v->y);
p->z= (cphi*u->z+sphi*v->z);

}


/*:81*/
#line 1016 "F:\Develop\mview3d\mathview3d.w"


/*:69*/
#line 27 "F:\Develop\mview3d\mathview3d.w"

/*45:*/
#line 677 "F:\Develop\mview3d\mathview3d.w"

/*43:*/
#line 649 "F:\Develop\mview3d\mathview3d.w"

PointList*PrependPointList(PointList*lst,int index,
double size,
double red,double green,double blue)
{PointList*head;

head= (PointList*)malloc(sizeof(PointList));
head->next= lst;
head->point= index;
head->size= size;
head->color.r= red;
head->color.g= green;
head->color.b= blue;
return head;
}

/*:43*/
#line 678 "F:\Develop\mview3d\mathview3d.w"

/*44:*/
#line 665 "F:\Develop\mview3d\mathview3d.w"

PointList*RemovePointList(PointList*lst)
{PointList*head;

while(lst){
head= lst;
lst= lst->next;
free(head);
}
return NULL;
}

/*:44*/
#line 679 "F:\Develop\mview3d\mathview3d.w"

/*:45*//*58:*/
#line 852 "F:\Develop\mview3d\mathview3d.w"

/*49:*/
#line 716 "F:\Develop\mview3d\mathview3d.w"

LinePolyList*PrependLinePolyList(LinePolyList*lst,
short int what,
int*lpoints,
int pno,
double r,double g,double b)
{LinePolyList*head;
int tri[3],*newpoints,nold;
int i,j;

if(lst&&Line3D==what&&lpoints[0]==lst->points[lst->pno-1]){
/*52:*/
#line 771 "F:\Develop\mview3d\mathview3d.w"

nold= lst->pno;
newpoints= (int*)calloc(nold+pno-1,sizeof(int));
memcpy(newpoints,lst->points,nold*sizeof(int));
memcpy(newpoints+nold,lpoints+1,(pno-1)*sizeof(int));
free(lst->points);
lst->points= newpoints;
lst->pno+= pno-1;
return lst;


/*:52*/
#line 727 "F:\Develop\mview3d\mathview3d.w"

}
if(Polygon3D==what&&pno>3){
if(COMTriangulation)
/*54:*/
#line 791 "F:\Develop\mview3d\mathview3d.w"

{Point3D cntr= {0.0,0.0,0.0};
int i;

head= lst;

for(i= 0;i<pno;i++){
cntr.x+= PointPool[lpoints[i]].x;
cntr.y+= PointPool[lpoints[i]].y;
cntr.z+= PointPool[lpoints[i]].z;
}
cntr.x/= pno;
cntr.y/= pno;
cntr.z/= pno;

tri[0]= AddToPointPool(cntr.x,cntr.y,cntr.z);

for(i= 1;i<pno;i++){
tri[1]= lpoints[i-1];
tri[2]= lpoints[i];
head= PrependLinePolyList(head,what,tri,3,r,g,b);
}
tri[1]= lpoints[pno-1];
tri[2]= lpoints[0];
return PrependLinePolyList(head,what,tri,3,r,g,b);
}

/*:54*/
#line 731 "F:\Develop\mview3d\mathview3d.w"

else
/*53:*/
#line 782 "F:\Develop\mview3d\mathview3d.w"

{int i;

head= PrependLinePolyList(lst,what,lpoints,3,r,g,b);
for(i= 1;i<pno-1;i++)
lpoints[i]= lpoints[i+1];
return PrependLinePolyList(head,what,lpoints,pno-1,r,g,b);
}

/*:53*/
#line 733 "F:\Develop\mview3d\mathview3d.w"

}
head= (LinePolyList*)malloc(sizeof(LinePolyList));
head->next= lst;
head->what= what;
head->pno= pno;
head->points= (int*)calloc(pno,sizeof(int));

head->points[0]= lpoints[0];
for(i= j= 1;i<pno;i++)
if(lpoints[i-1]!=lpoints[i])
head->points[j++]= lpoints[i];
if(j!=pno)head->pno= j;
head->color.r= r;
head->color.g= g;
head->color.b= b;
head->aux1= -1;
head->aux2= -1.0;
return head;
}

/*:49*/
#line 853 "F:\Develop\mview3d\mathview3d.w"


/*:58*//*67:*/
#line 993 "F:\Develop\mview3d\mathview3d.w"

/*65:*/
#line 943 "F:\Develop\mview3d\mathview3d.w"

int AddToPointPool(double x,double y,double z)
{int pn,i;
double d;
Point3D*pos,**nvec;

if(!PointPool){
PointPool= (Point3D*)calloc(MaxPoolSize= INIT_POOLSIZE,sizeof(Point3D));
NormalPool= (Point3D**)calloc(INIT_POOLSIZE,sizeof(Point3D*));
for(i= 0;i<MaxPoolSize;i++)
NormalPool[i]= NULL;
PoolSize= 0;
}
pn= PoolSize;
pos= PointPool;
for(i= 0;i<pn;i++,pos++){
d= fabs(x-pos->x)+fabs(y-pos->y)+fabs(z-pos->z);
if(d<TINY)return i;
}
if(pn==MaxPoolSize){
pos= (Point3D*)calloc(MaxPoolSize+POOL_INC,sizeof(Point3D));
memcpy(pos,PointPool,MaxPoolSize*sizeof(Point3D));
free(PointPool);
PointPool= pos;
nvec= (Point3D**)calloc(MaxPoolSize+POOL_INC,sizeof(Point3D*));
memcpy(nvec,NormalPool,MaxPoolSize*sizeof(Point3D*));
free(NormalPool);
NormalPool= nvec;
MaxPoolSize+= POOL_INC;
for(i= PoolSize;i<MaxPoolSize;i++)
NormalPool[i]= NULL;
}

PointPool[pn].x= x;
PointPool[pn].y= y;
PointPool[pn].z= z;
/*66:*/
#line 983 "F:\Develop\mview3d\mathview3d.w"

if(BoundP1.x>x)BoundP1.x= x;
if(BoundP2.x<x)BoundP2.x= x;
if(BoundP1.y>y)BoundP1.y= y;
if(BoundP2.y<y)BoundP2.y= y;
if(BoundP1.z>z)BoundP1.z= z;
if(BoundP2.z<z)BoundP2.z= z;



/*:66*/
#line 979 "F:\Develop\mview3d\mathview3d.w"

return PoolSize++;
}

/*:65*/
#line 994 "F:\Develop\mview3d\mathview3d.w"


/*:67*/
#line 28 "F:\Develop\mview3d\mathview3d.w"

/*57:*/
#line 848 "F:\Develop\mview3d\mathview3d.w"

/*50:*/
#line 754 "F:\Develop\mview3d\mathview3d.w"

LinePolyList*RemoveLinePolyList(LinePolyList*lst)
{LinePolyList*head;

while(lst){
free(lst->points);
head= lst->next;
free(lst);
lst= head;
}
return NULL;
}

/*:50*/
#line 849 "F:\Develop\mview3d\mathview3d.w"

/*56:*/
#line 830 "F:\Develop\mview3d\mathview3d.w"

void ReversePolygons(LinePolyList*lst)
{int n,tmp;

while(lst){
if(Polygon3D==lst->what){
n= lst->pno;
if(3==n){
tmp= lst->points[2];
lst->points[2]= lst->points[0];
lst->points[0]= tmp;
}
}
lst= lst->next;
}
}


/*:56*/
#line 850 "F:\Develop\mview3d\mathview3d.w"


/*:57*/
#line 29 "F:\Develop\mview3d\mathview3d.w"

/*85:*/
#line 1295 "F:\Develop\mview3d\mathview3d.w"

/*86:*/
#line 1300 "F:\Develop\mview3d\mathview3d.w"

#define KEYWORDNO 8
#define BBOX      0
#define VPOINT    1
#define LSOURCE   2
#define POINT     3
#define LINE      4
#define POLY      5
#define AMBIENT   6
#define COLOR     7

char*Keyword[KEYWORDNO]= {"boundingbox",
"viewpoint",
"lightsources",
"point",
"line",
"polygon",
"ambient",
"color"};

/*:86*/
#line 1296 "F:\Develop\mview3d\mathview3d.w"

/*87:*/
#line 1320 "F:\Develop\mview3d\mathview3d.w"

int SearchKeyWord(char*cline)
{int i;
for(i= 0;i<KEYWORDNO;i++)
if(cline==strstr(cline,Keyword[i])){
return i;
}
return-1;
}


/*:87*/
#line 1297 "F:\Develop\mview3d\mathview3d.w"

/*88:*/
#line 1331 "F:\Develop\mview3d\mathview3d.w"

void Scan3ScriptFile(char*fname)
{char cline[MAX_STRING];
FILE*infile;
int key,i;
int plBuffer[2048];
double x,y,z,red,green,blue,sred,sblue,sgreen;
double psize,thickness;
if(!(infile= fopen(fname,"r")))return;
strcpy(cline,"");
red= green= blue= 0.0;
sred= sgreen= sblue= 1.0;
psize= thickness= 0.001;
while(!feof(infile)){
if(!*cline)
fgets(cline,MAX_STRING,infile);
key= SearchKeyWord(cline);
if(key<0){
strcpy(cline,"");
continue;
}
switch(key){
case BBOX:/*92:*/
#line 1396 "F:\Develop\mview3d\mathview3d.w"

fscanf(infile,"%lg %lg %lg\n",&(BoundP1.x),&(BoundP1.y),&(BoundP1.z));
fscanf(infile,"%lg %lg %lg\n",&(BoundP2.x),&(BoundP2.y),&(BoundP2.z));
strcpy(cline,"");

/*:92*/
#line 1353 "F:\Develop\mview3d\mathview3d.w"
break;
case VPOINT:/*93:*/
#line 1401 "F:\Develop\mview3d\mathview3d.w"

fscanf(infile,"%lg %lg %lg\n",
&(ViewPoint.x),
&(ViewPoint.y),
&(ViewPoint.z));
strcpy(cline,"");

/*:93*/
#line 1354 "F:\Develop\mview3d\mathview3d.w"
break;
case LSOURCE:/*95:*/
#line 1412 "F:\Develop\mview3d\mathview3d.w"

fgets(cline,MAX_STRING,infile);
i= 0;
do{
sscanf(cline,"%lg %lg %lg",
&(LightPosition[i].x),&(LightPosition[i].y),&(LightPosition[i].z));
fgets(cline,MAX_STRING,infile);
sscanf(cline,"%lg %lg %lg",
&(LightColor[i].r),&(LightColor[i].g),&(LightColor[i].b));
fgets(cline,MAX_STRING,infile);
LightNo++;
i++;
if(i>=MAX_LIGHT)break;
}
while(SearchKeyWord(cline)<0);

/*:95*/
#line 1355 "F:\Develop\mview3d\mathview3d.w"
break;
case POINT:/*91:*/
#line 1390 "F:\Develop\mview3d\mathview3d.w"

fscanf(infile,"%lg %lg %lg\n",&x,&y,&z);
i= AddToPointPool(x,y,z);
Points= PrependPointList(Points,i,psize,red,green,blue);
strcpy(cline,"");

/*:91*/
#line 1356 "F:\Develop\mview3d\mathview3d.w"
break;
case LINE:/*90:*/
#line 1378 "F:\Develop\mview3d\mathview3d.w"

i= 0;
fgets(cline,MAX_STRING,infile);
do{
sscanf(cline,"%lg %lg %lg\n",&x,&y,&z);
plBuffer[i]= AddToPointPool(x,y,z);
i++;
fgets(cline,MAX_STRING,infile);
}
while(SearchKeyWord(cline)<0&&!feof(infile));
Lines= PrependLinePolyList(Lines,Line3D,plBuffer,i,red,green,blue);

/*:90*/
#line 1357 "F:\Develop\mview3d\mathview3d.w"
break;
case POLY:/*89:*/
#line 1366 "F:\Develop\mview3d\mathview3d.w"

i= 0;
fgets(cline,MAX_STRING,infile);
do{
sscanf(cline,"%lg %lg %lg\n",&x,&y,&z);
plBuffer[i]= AddToPointPool(x,y,z);
i++;
fgets(cline,MAX_STRING,infile);
}
while(SearchKeyWord(cline)<0&&!feof(infile));
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,i,sred,sgreen,sblue);

/*:89*/
#line 1358 "F:\Develop\mview3d\mathview3d.w"
break;
case AMBIENT:/*96:*/
#line 1428 "F:\Develop\mview3d\mathview3d.w"

fgets(cline,MAX_STRING,infile);
sscanf(cline,"%lg %lg %lg",&AmbientColor.r,&AmbientColor.g,&AmbientColor.b);
strcpy(cline,"");

/*:96*/
#line 1359 "F:\Develop\mview3d\mathview3d.w"
break;
case COLOR:/*94:*/
#line 1408 "F:\Develop\mview3d\mathview3d.w"

fscanf(infile,"%lg %lg %lg\n",&red,&green,&blue);
strcpy(cline,"");

/*:94*/
#line 1360 "F:\Develop\mview3d\mathview3d.w"
break;
}
}
fclose(infile);
}

/*:88*/
#line 1298 "F:\Develop\mview3d\mathview3d.w"


/*:85*/
#line 30 "F:\Develop\mview3d\mathview3d.w"

/*62:*/
#line 888 "F:\Develop\mview3d\mathview3d.w"

void AveragedNormals(LinePolyList*lst)
{int i,j1,j2,j3;
Point3D normal;
int*cnt,res;
double n;

cnt= (int*)calloc(PoolSize,sizeof(int));
for(i= 0;i<PoolSize;i++)cnt[i]= 0;
while(lst){
for(i= 0;i<lst->pno;i++){
/*61:*/
#line 882 "F:\Develop\mview3d\mathview3d.w"

j1= lst->points[0==i?lst->pno-1:i-1];
j2= lst->points[i];
j3= lst->points[lst->pno-1==i?0:i+1];

/*:61*/
#line 899 "F:\Develop\mview3d\mathview3d.w"

res= SurfaceNormal(&normal,PointPool+j1,PointPool+j2,PointPool+j3);
if(!res)continue;
if(!NormalPool[j2]){
NormalPool[j2]= (Point3D*)malloc(sizeof(Point3D));
NormalPool[j2]->x= NormalPool[j2]->y= NormalPool[j2]->z= 0.0;
}
NormalPool[j2]->x+= normal.x;
NormalPool[j2]->y+= normal.y;
NormalPool[j2]->z+= normal.z;
cnt[j2]++;
}
lst= lst->next;
}
for(i= 0;i<PoolSize;i++)
if(cnt[i]&&NormalPool[i]){
NormalPool[i]->x/= cnt[i];
NormalPool[i]->y/= cnt[i];
NormalPool[i]->z/= cnt[i];
n= Norm(NormalPool[i]);
if(n>0.0){
NormalPool[i]->x/= n;
NormalPool[i]->y/= n;
NormalPool[i]->z/= n;
}
else{
free(NormalPool[i]);
NormalPool[i]= NULL;
}
}
free(cnt);
}

/*:62*/
#line 31 "F:\Develop\mview3d\mathview3d.w"

/*55:*/
#line 818 "F:\Develop\mview3d\mathview3d.w"

long int LengthLinePolyList(LinePolyList*lst)
{
long int len= 0;

while(lst){
len++;
lst= lst->next;
}
return len;
}

/*:55*/
#line 32 "F:\Develop\mview3d\mathview3d.w"

/*97:*/
#line 1440 "F:\Develop\mview3d\mathview3d.w"

/*82:*/
#line 1195 "F:\Develop\mview3d\mathview3d.w"

void MakeCone(Point3D*p1,Point3D*p2,double r,int n)
{Point3D v1,v2,v3,vn,p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;

dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn= *p;
IncPoint3D(p[0],(*p1))
AddPoint3D(p[1],p[0],v1)
glBegin(GL_TRIANGLE_STRIP);
glVertex3d(p[0].x,p[0].y,p[0].z);
glNormal3d(vn.x,vn.y,vn.z);
glVertex3d(p[1].x,p[1].y,p[1].z);
glNormal3d(vn.x,vn.y,vn.z);
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn= p[2];
IncPoint3D(p[2],(*p1))
AddPoint3D(p[3],p[2],v1)
glVertex3d(p[2].x,p[2].y,p[2].z);
glNormal3d(vn.x,vn.y,vn.z);

glVertex3d(p[3].x,p[3].y,p[3].z);
glNormal3d(vn.x,vn.y,vn.z);

}
glEnd();

}

/*:82*/
#line 1441 "F:\Develop\mview3d\mathview3d.w"

/*83:*/
#line 1239 "F:\Develop\mview3d\mathview3d.w"

void MakeConeContinued(Point3D*p1,Point3D*p2,Point3D*p3,
double r,int n)
{Point3D v1,v2,v3,u1,u2,u3,vn1,vn2,p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;v1.y= p2->y-p1->y;v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);
u1.x= p3->x-p2->x;u1.y= p3->y-p2->y;u1.z= p3->z-p2->z;
norm= Norm(&u1);
u1.x/= norm;u1.y/= norm;u1.z/= norm;
/*84:*/
#line 1287 "F:\Develop\mview3d\mathview3d.w"

if(Dot(&u1,&v1)<CosSkipCont){
MakeCone(p1,p2,r,n);
MakeCone(p2,p3,r,n);
return;
}

/*:84*/
#line 1254 "F:\Develop\mview3d\mathview3d.w"

u2= v2;u3= v3;
GramSchmidt(&u1,&u2,&u3);
dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn1= *p;
IncPoint3D(p[0],(*p1))
ConePoint(r,0.0,&u2,&u3,p+1);
vn2= p[1];
IncPoint3D(p[1],(*p2))
glBegin(GL_TRIANGLE_STRIP);
glVertex3d(p[0].x,p[0].y,p[0].z);
glNormal3d(vn1.x,vn1.y,vn1.z);
glVertex3d(p[1].x,p[1].y,p[1].z);
glNormal3d(vn2.x,vn2.y,vn2.z);
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn1= p[2];
IncPoint3D(p[2],(*p1))
ConePoint(r,i*dphi,&u2,&u3,p+3);
vn2= p[3];
IncPoint3D(p[3],(*p2));
glVertex3d(p[2].x,p[2].y,p[2].z);
glNormal3d(vn1.x,vn1.y,vn1.z);

glVertex3d(p[3].x,p[3].y,p[3].z);
glNormal3d(vn2.x,vn2.y,vn2.z);

}
glEnd();

}

/*:83*/
#line 1442 "F:\Develop\mview3d\mathview3d.w"

/*105:*/
#line 1596 "F:\Develop\mview3d\mathview3d.w"

void PointSphere(Point3D*cnt,double r,int nphi,int ntheta,
float colorRed,float colorGreen,float colorBlue)
{int i,j,count;
double phi,theta;
double dphi,dtheta;
register double cp,sp,ct,st;
register double cp1,sp1,ct1,st1;
Point3D p0,p;
float mat[4]= {1.0f,1.0f,1.0f,1.0f};


dphi= TWO_PI/nphi;
dtheta= PI/ntheta;
mat[0]= colorRed;mat[1]= colorGreen;mat[1]= colorBlue;
glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,mat);

for(i= 0,count= 0;i<nphi;i++){
cp= cos(phi= i*dphi);
sp= sin(phi);
cp1= cos(phi= (i+1)*dphi);
sp1= sin(phi);
for(j= 0;j<ntheta;j++){
ct= cos(theta= j*dtheta);
st= sin(theta);
ct1= cos(theta= (j+1)*dtheta);
st1= sin(theta);
if(count++&1){
p.x= cp*st;p.y= sp*st;p.z= ct;
p0= p;
/*106:*/
#line 1641 "F:\Develop\mview3d\mathview3d.w"

glBegin(GL_POLYGON);
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1643 "F:\Develop\mview3d\mathview3d.w"

p.x= cp1*st;p.y= sp1*st;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1645 "F:\Develop\mview3d\mathview3d.w"

p.x= cp1*st1;p.y= sp1*st1;p.z= ct1;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1647 "F:\Develop\mview3d\mathview3d.w"

glEnd();

/*:106*/
#line 1626 "F:\Develop\mview3d\mathview3d.w"

/*107:*/
#line 1650 "F:\Develop\mview3d\mathview3d.w"

glBegin(GL_POLYGON);
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1652 "F:\Develop\mview3d\mathview3d.w"

p.x= cp*st1;p.y= sp*st1;p.z= ct1;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1654 "F:\Develop\mview3d\mathview3d.w"

p= p0;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1656 "F:\Develop\mview3d\mathview3d.w"

glEnd();

/*:107*/
#line 1627 "F:\Develop\mview3d\mathview3d.w"

}
else{
p.x= cp*st1;p.y= sp*st1;p.z= ct1;
p0= p;
/*108:*/
#line 1659 "F:\Develop\mview3d\mathview3d.w"

glBegin(GL_POLYGON);
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1661 "F:\Develop\mview3d\mathview3d.w"

p.x= cp*st;p.y= sp*st;p.z= ct;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1663 "F:\Develop\mview3d\mathview3d.w"

p.x= cp1*st;p.y= sp1*st;p.z= ct;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1665 "F:\Develop\mview3d\mathview3d.w"

glEnd();

/*:108*/
#line 1632 "F:\Develop\mview3d\mathview3d.w"

/*109:*/
#line 1668 "F:\Develop\mview3d\mathview3d.w"

glBegin(GL_POLYGON);
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1670 "F:\Develop\mview3d\mathview3d.w"

p.x= cp1*st1;p.y= sp1*st1;p.z= ct1;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1672 "F:\Develop\mview3d\mathview3d.w"

p= p0;
/*110:*/
#line 1678 "F:\Develop\mview3d\mathview3d.w"

glVertex3d(r*p.x+cnt->x,r*p.y+cnt->y,r*p.z+cnt->z);
glNormal3d(p.x,p.y,p.z);

/*:110*/
#line 1674 "F:\Develop\mview3d\mathview3d.w"

glEnd();


/*:109*/
#line 1633 "F:\Develop\mview3d\mathview3d.w"

}
}
}
mat[0]= 1.f;mat[1]= 1.f;mat[1]= 1.0;
glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,mat);
}

/*:105*/
#line 1443 "F:\Develop\mview3d\mathview3d.w"

/*111:*/
#line 1682 "F:\Develop\mview3d\mathview3d.w"

void GLPrintPointList(PointList*lst)
{
Point3D*p;

if(0.0>=PointSphereSize){
glDisable(GL_LIGHTING);
while(lst){
p= PointPool+lst->point;
glBegin(GL_POINTS);
glVertex3d(p->x,p->y,p->z);
glEnd();
lst= lst->next;
}
glEnable(GL_LIGHTING);
}
else{
while(lst){
p= PointPool+lst->point;
PointSphere(p,lst->size*PointSphereSize,
PointSphereSegmentsPhi,
PointSphereSegmentsTheta,
lst->color.r,
lst->color.g,
lst->color.b
);
lst= lst->next;
}
}

}

/*:111*/
#line 1444 "F:\Develop\mview3d\mathview3d.w"

/*112:*/
#line 1714 "F:\Develop\mview3d\mathview3d.w"

void GLPrintLinePolyList(LinePolyList*lst)
{int i,thisI;
int j1,j2,j3;
Point3D p,normal;
float mat[4]= {1.0f,1.0f,1.0f,1.0f};
while(lst){
switch(lst->what){
case Polygon3D:
mat[0]= (float)lst->color.r;
mat[1]= (float)lst->color.g;
mat[2]= (float)lst->color.b;
glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,mat);
mat[0]= (float)lst->color.r;
mat[1]= (float)lst->color.g;
mat[2]= (float)lst->color.b;
glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,mat);

if(WireFrame)
glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
else
glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
glBegin(GL_POLYGON);
for(i= 0;i<lst->pno;i++){
p= PointPool[thisI= lst->points[i]];
if(NormalPool[thisI]&&SmoothShading)
glNormal3d(NormalPool[thisI]->x,
NormalPool[thisI]->y,
NormalPool[thisI]->z);
else{
/*61:*/
#line 882 "F:\Develop\mview3d\mathview3d.w"

j1= lst->points[0==i?lst->pno-1:i-1];
j2= lst->points[i];
j3= lst->points[lst->pno-1==i?0:i+1];

/*:61*/
#line 1744 "F:\Develop\mview3d\mathview3d.w"

if(SurfaceNormal(&normal,PointPool+j1,PointPool+j2,PointPool+j3))
glNormal3d(normal.x,normal.y,normal.z);
}
glVertex3d(p.x,p.y,p.z);
}
glEnd();
break;
case Line3D:
if(0.0<LineTubeSize)
/*113:*/
#line 1763 "F:\Develop\mview3d\mathview3d.w"

{if(2==lst->pno)
MakeCone(PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
else{
for(i= 0;i<lst->pno-2;i++)
MakeConeContinued(
PointPool+lst->points[i],
PointPool+lst->points[i+1],
PointPool+lst->points[i+2],
LineTubeSize,TubeSegments);
i= lst->pno-2;
if(lst->points[0]==lst->points[i+1]){
MakeConeContinued(
PointPool+lst->points[i],
PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
}
else
MakeCone(PointPool+lst->points[i],
PointPool+lst->points[i+1],
LineTubeSize,TubeSegments);

}
}

/*:113*/
#line 1754 "F:\Develop\mview3d\mathview3d.w"

else
/*114:*/
#line 1791 "F:\Develop\mview3d\mathview3d.w"

{
glBegin(lst->pno>2?GL_LINE_STRIP:GL_LINES);
for(i= 0;i<lst->pno;i++){
p= PointPool[lst->points[i]];
glVertex3d(p.x,p.y,p.z);
}
glEnd();
}

/*:114*/
#line 1756 "F:\Develop\mview3d\mathview3d.w"

break;
}
lst= lst->next;
}
}

/*:112*/
#line 1445 "F:\Develop\mview3d\mathview3d.w"

/*115:*/
#line 1801 "F:\Develop\mview3d\mathview3d.w"

void GLPrintOutlinePolyList(LinePolyList*lst,RGBColor c)
{int i,thisI;
int j1,j2,j3;
Point3D p;

glDisable(GL_LIGHTING);
glLineWidth(2.0f);
glColor3d(c.r,c.g,c.b);
glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
while(lst){
glBegin(GL_POLYGON);
for(i= 0;i<lst->pno;i++){
p= PointPool[thisI= lst->points[i]];
glVertex3d(p.x,p.y,p.z);
}
glEnd();
lst= lst->next;
}
glLineWidth(1.0f);
glEnable(GL_LIGHTING);

}

/*:115*/
#line 1446 "F:\Develop\mview3d\mathview3d.w"

/*102:*/
#line 1537 "F:\Develop\mview3d\mathview3d.w"

void ScalingToUnitCube(Point3D p1,Point3D p2)
{Point3D scale= {1.0,1.0,1.0};
double is;

ScaleOfScene.x= scale.x= 0.5*(p2.x-p1.x);
ScaleOfScene.y= scale.y= 0.5*(p2.y-p1.y);
ScaleOfScene.z= scale.z= 0.5*(p2.z-p1.z);
MaxScaleOfScene= MAX3(ScaleOfScene.x,ScaleOfScene.y,ScaleOfScene.z);
if(MaxScaleOfScene!=0.0)
is= 1.0/MaxScaleOfScene;
else
is= 1.0;
if(scale.x==0.0)scale.x= 1.0;
if(scale.y==0.0)scale.y= 1.0;
if(scale.z==0.0)scale.z= 1.0;

glScaled(is,is,is);
}

/*:102*/
#line 1447 "F:\Develop\mview3d\mathview3d.w"

/*103:*/
#line 1557 "F:\Develop\mview3d\mathview3d.w"

void DefineLightSources(void)
{int i;
float flt[4]= {0.0f,0.0f,0.0f,1.0f};
float material_diff[4]= {1.0f,1.0f,1.0f,1.0f};
float material_spec[4]= {0.5f,0.5f,0.5f,1.0f};
float bmaterial_diff[4]= {0.5f,0.5f,0.5f,1.0f};
float bmaterial_spec[4]= {0.0f,0.0f,0.0f,1.0f};

/*104:*/
#line 1573 "F:\Develop\mview3d\mathview3d.w"

glEnable(GL_LIGHTING);
for(i= 0;i<LightNo;i++){
glEnable(GL_LIGHT0+i);
flt[0]= LightPosition[i].x;flt[1]= LightPosition[i].y;flt[2]= LightPosition[i].z;
flt[3]= 0.0;
glLightfv(GL_LIGHT0+i,GL_POSITION,flt);
flt[0]= LightColor[i].r;flt[1]= LightColor[i].g;flt[2]= LightColor[i].b;
flt[3]= 1.0;
glLightfv(GL_LIGHT0+i,GL_SPECULAR,flt);
flt[0]= LightColor[i].r;
flt[1]= LightColor[i].g;
flt[2]= LightColor[i].b;
glLightfv(GL_LIGHT0+i,GL_DIFFUSE,flt);
flt[0]= AmbientColor.r;flt[1]= AmbientColor.g;flt[2]= AmbientColor.b;
glLightfv(GL_LIGHT0+i,GL_AMBIENT,flt);

}

/*:104*/
#line 1566 "F:\Develop\mview3d\mathview3d.w"

glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,material_diff);
glMaterialfv(GL_FRONT,GL_SPECULAR,material_spec);
glMaterialfv(GL_BACK,GL_AMBIENT_AND_DIFFUSE,bmaterial_diff);
glMaterialfv(GL_BACK,GL_SPECULAR,bmaterial_spec);
}

/*:103*/
#line 1448 "F:\Develop\mview3d\mathview3d.w"

/*100:*/
#line 1501 "F:\Develop\mview3d\mathview3d.w"

void CreateObject(void)
{

if(PointPool){
glPushMatrix();

if(ObjID<0)
ObjID= glGenLists(1);
else{
glDeleteLists(ObjID,1);
ObjID= glGenLists(1);
}

glNewList(ObjID,GL_COMPILE);
if(Points)
GLPrintPointList(Points);
if(Lines)
GLPrintLinePolyList(Lines);
if(Polygons)
GLPrintLinePolyList(Polygons);
if(PolyOutline)
GLPrintOutlinePolyList(Polygons,White);
glEndList();
glPopMatrix();
}
}

/*:100*/
#line 1449 "F:\Develop\mview3d\mathview3d.w"

/*99:*/
#line 1463 "F:\Develop\mview3d\mathview3d.w"

void RecalcView(double fac)
{double vr,vphi,vtheta,bound1,bound2;
Point3D vp;

glMatrixMode(GL_PROJECTION);
glLoadIdentity();
gluPerspective(MVViewAngle,
1.0,
MVNearPlane,MVFarPlane);
glMatrixMode(GL_MODELVIEW);
glLoadIdentity();
SphericalFromCartesian(&ViewPoint,&vr,&vtheta,&vphi);
bound1= Norm(&BoundP1);
bound2= Norm(&BoundP2);
vp.x= fac*vr*cos(vphi)*sin(vtheta);
vp.y= fac*vr*sin(vphi)*sin(vtheta);
vp.z= fac*vr*cos(vtheta);
CenterOfScene.x= 0.5*(BoundP1.x+BoundP2.x);
CenterOfScene.y= 0.5*(BoundP1.y+BoundP2.y);
CenterOfScene.z= 0.5*(BoundP1.z+BoundP2.z);
gluLookAt(vp.x,vp.y,vp.z,
0.0,0.0,0.0,
0.0,0.0,1.0);
DefineLightSources();

ScalingToUnitCube(BoundP1,BoundP2);
glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);

glPushMatrix();

}


/*:99*/
#line 1450 "F:\Develop\mview3d\mathview3d.w"

/*98:*/
#line 1455 "F:\Develop\mview3d\mathview3d.w"

void InitView(void)
{
glEnable(GL_DEPTH_TEST);
CreateObject();
RecalcView(1.0);
}

/*:98*/
#line 1451 "F:\Develop\mview3d\mathview3d.w"



/*:97*/
#line 33 "F:\Develop\mview3d\mathview3d.w"

/*40:*/
#line 634 "F:\Develop\mview3d\mathview3d.w"

/*39:*/
#line 626 "F:\Develop\mview3d\mathview3d.w"

void MathPrintPosition(FILE*f,int index)
{Point3D*p;

p= PointPool+index;
fprintf(f,"{ %lg, %lg, %lg}",p->x,p->y,p->z);
}

/*:39*/
#line 635 "F:\Develop\mview3d\mathview3d.w"



/*:40*//*47:*/
#line 698 "F:\Develop\mview3d\mathview3d.w"

/*46:*/
#line 680 "F:\Develop\mview3d\mathview3d.w"

void MathPrintPointList(FILE*f,PointList*lst)
{
fprintf(f,"{");
while(lst){
fprintf(f,"\t{PointSize[%lg], RGBColor[%lg, %lg, %lg], Point[",
lst->size,
lst->color.r,
lst->color.g,
lst->color.b);
MathPrintPosition(f,lst->point);
fprintf(f,"]}");
if(lst->next)fprintf(f,",\n");
lst= lst->next;
}
fprintf(f,"}");
}

/*:46*/
#line 699 "F:\Develop\mview3d\mathview3d.w"


/*:47*//*60:*/
#line 879 "F:\Develop\mview3d\mathview3d.w"

/*59:*/
#line 855 "F:\Develop\mview3d\mathview3d.w"

void MathPrintLinePolyList(FILE*f,LinePolyList*lst)
{int i;

fprintf(f,"{");
while(lst){
fprintf(f,"{\n\t%s[%lg, %lg, %lg]%s,\n\t%s[{",
Line3D==lst->what?"RGBColor":"SurfaceColor[RGBColor[",
lst->color.r,
lst->color.g,
lst->color.b,
Line3D==lst->what?"":"]",
Line3D==lst->what?"Line":"Polygon");
for(i= 0;i<lst->pno;i++){
MathPrintPosition(f,lst->points[i]);
if(i!=lst->pno-1)
fprintf(f,",");
}
fprintf(f,lst->next?"}]},\n":"}]}");
}
fprintf(f,"}\n");
}


/*:59*/
#line 880 "F:\Develop\mview3d\mathview3d.w"


/*:60*/
#line 34 "F:\Develop\mview3d\mathview3d.w"

/*8:*/
#line 155 "F:\Develop\mview3d\mathview3d.w"

void MVTrackball(double*angle,
Point3D*axis,
int x1,int y1,
int x2,int y2)
{double phi1,theta1,phi2,theta2,n;
Point3D v1,v2;

phi1= PI*(2.0*x1-ScreenWidth)/((double)ScreenWidth);
phi2= PI*(2.0*x2-ScreenWidth)/((double)ScreenWidth);
theta1= PI*(ScreenHeight-y1)/((double)ScreenHeight);
theta2= PI*(ScreenHeight-y2)/((double)ScreenHeight);
CartesianFromSpherical(1.0,theta1,phi1,&v1);
CartesianFromSpherical(1.0,theta2,phi2,&v2);
Cross(axis,&v2,&v1);
n= Norm(axis);
if(n>0.0){
axis->x/= n;
axis->y/= n;
axis->z/= n;
}
else{
axis->x= axis->y= 0.0;
axis->z= 1.0;
}
*angle= acos(Dot(&v1,&v2));
}

/*:8*/
#line 35 "F:\Develop\mview3d\mathview3d.w"

/*116:*/
#line 1826 "F:\Develop\mview3d\mathview3d.w"

/*118:*/
#line 1849 "F:\Develop\mview3d\mathview3d.w"

void WritePOVVector(FILE*f,char*pre,Point3D*p,char*post)
{
fprintf(f,"%s<%lg, %lg, %lg>%s",pre,p->x,p->y,p->z,post);
}

/*:118*/
#line 1827 "F:\Develop\mview3d\mathview3d.w"

/*122:*/
#line 1899 "F:\Develop\mview3d\mathview3d.w"

int CheckNormals(int*points,int no)
{int res,i;

res= NULL!=NormalPool[points[0]];
for(i= 1;i<no&&res;i++)
res= res&&(NULL!=NormalPool[points[i]]);
return res;
}

/*:122*/
#line 1828 "F:\Develop\mview3d\mathview3d.w"

/*124:*/
#line 1936 "F:\Develop\mview3d\mathview3d.w"

void WritePOVSmoothTriangle(FILE*f,
Point3D*p1,Point3D*p2,Point3D*p3,
Point3D*n1,Point3D*n2,Point3D*n3)
{
fprintf(f,"\tsmooth_triangle {\n");
WritePOVVector(f,"\t",p1,", ");WritePOVVector(f,"",n1,",\n");
WritePOVVector(f,"\t",p2,", ");WritePOVVector(f,"",n2,",\n");
WritePOVVector(f,"\t",p3,", ");WritePOVVector(f,"",n3,"\n");
fprintf(f,"\t}\n");
}

/*:124*/
#line 1829 "F:\Develop\mview3d\mathview3d.w"

/*120:*/
#line 1869 "F:\Develop\mview3d\mathview3d.w"

void POVTrackballPosition(FILE*f)
{char mstr[256];
Point3D p1;

p1.x= -CenterOfScene.x;
p1.y= -CenterOfScene.y;
p1.z= -CenterOfScene.z;
WritePOVVector(f,"\ttranslate ",&p1,"\n");
sprintf(mstr,"\trotate %lg*",ToDegree*TrackAngle);
WritePOVVector(f,mstr,&TrackAxis,"\n");
WritePOVVector(f,"\ttranslate ",&CenterOfScene,"\n");
}

/*:120*/
#line 1830 "F:\Develop\mview3d\mathview3d.w"

/*125:*/
#line 1948 "F:\Develop\mview3d\mathview3d.w"

void MakePOVCone(FILE*f,Point3D*p1,Point3D*p2,double r,int n)
{Point3D v1,v2,v3,vn[4],p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;

dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn[0]= vn[1]= *p;
IncPoint3D(p[0],(*p1))
AddPoint3D(p[1],p[0],v1)
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn[2]= p[2];
IncPoint3D(p[2],(*p1))
WritePOVSmoothTriangle(f,p,p+1,p+2,vn,vn+1,vn+2);
AddPoint3D(p[3],p[2],v1)
vn[3]= vn[2];
WritePOVSmoothTriangle(f,p+2,p+1,p+3,vn+2,vn+1,vn+3);
p[0]= p[2];vn[0]= vn[2];
p[1]= p[3];vn[1]= vn[3];
}
}

/*:125*/
#line 1831 "F:\Develop\mview3d\mathview3d.w"

/*126:*/
#line 1984 "F:\Develop\mview3d\mathview3d.w"

void MakePOVConeContinued(FILE*f,Point3D*p1,Point3D*p2,Point3D*p3,
double r,int n)
{Point3D v1,v2,v3,u1,u2,u3,vn[4],p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;v1.y= p2->y-p1->y;v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);
u1.x= p3->x-p2->x;u1.y= p3->y-p2->y;u1.z= p3->z-p2->z;
norm= Norm(&u1);
u1.x/= norm;u1.y/= norm;u1.z/= norm;
/*127:*/
#line 2024 "F:\Develop\mview3d\mathview3d.w"

if(Dot(&u1,&v1)<CosSkipCont){
MakePOVCone(f,p1,p2,r,n);
MakePOVCone(f,p2,p3,r,n);
return;
}

/*:127*/
#line 1999 "F:\Develop\mview3d\mathview3d.w"

u2= v2;u3= v3;
GramSchmidt(&u1,&u2,&u3);
dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn[0]= *p;
IncPoint3D(p[0],(*p1))
ConePoint(r,0.0,&u2,&u3,p+1);
vn[1]= p[1];
IncPoint3D(p[1],(*p2))
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn[2]= p[2];
IncPoint3D(p[2],(*p1))
WritePOVSmoothTriangle(f,p,p+1,p+2,vn,vn+1,vn+2);
ConePoint(r,i*dphi,&u2,&u3,p+3);
vn[3]= p[3];
IncPoint3D(p[3],(*p2))
WritePOVSmoothTriangle(f,p+2,p+1,p+3,vn+2,vn+1,vn+3);
p[0]= p[2];vn[0]= vn[2];
p[1]= p[3];vn[1]= vn[3];

}
}

/*:126*/
#line 1832 "F:\Develop\mview3d\mathview3d.w"

/*121:*/
#line 1883 "F:\Develop\mview3d\mathview3d.w"

void WritePOVPoints(FILE*f,PointList*lst)
{
fprintf(f,"/* Begin Points */\n\n union {\n");
while(lst){
fprintf(f,"\tsphere {\n");
WritePOVVector(f,"\t",PointPool+lst->point," ");
fprintf(f,"%lg \n\t}\n",PointSphereSize*lst->size);
lst= lst->next;
}
if(TrackAngle!=0.0)
POVTrackballPosition(f);
fprintf(f,"}\n/* End of Points */\n");

}

/*:121*/
#line 1833 "F:\Develop\mview3d\mathview3d.w"

/*128:*/
#line 2031 "F:\Develop\mview3d\mathview3d.w"

void WritePOVLines(FILE*f,LinePolyList*lst)
{int i,cnt;

fprintf(f,"/* Begin lines */\n");
if(0.0<LineTubeSize){
cnt= 1;
while(lst){
fprintf(f,"/* Line %d */\n",cnt);
fprintf(f,"mesh {\n");
/*129:*/
#line 2053 "F:\Develop\mview3d\mathview3d.w"

{if(2==lst->pno)
MakePOVCone(f,PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
else{
for(i= 0;i<lst->pno-2;i++)
MakePOVConeContinued(f,
PointPool+lst->points[i],
PointPool+lst->points[i+1],
PointPool+lst->points[i+2],
LineTubeSize,TubeSegments);
i= lst->pno-2;
if(lst->points[0]==lst->points[i+1]){
MakePOVConeContinued(f,
PointPool+lst->points[i],
PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
}
else
MakePOVCone(f,PointPool+lst->points[i],
PointPool+lst->points[i+1],
LineTubeSize,TubeSegments);
}
}


/*:129*/
#line 2041 "F:\Develop\mview3d\mathview3d.w"

if(TrackAngle!=0.0)
POVTrackballPosition(f);
fprintf(f,"}\n/* End of Line %d*/\n",cnt++);
lst= lst->next;
}
}
else
fprintf(f,"// Line output skiped due to zero LineTubeSize\n");
fprintf(f,"/* End lines */");
}

/*:128*/
#line 1834 "F:\Develop\mview3d\mathview3d.w"

/*123:*/
#line 1909 "F:\Develop\mview3d\mathview3d.w"

void WritePOVTriangles(FILE*f,LinePolyList*lst,int smooth)
{int i,thisI;
Point3D*p;
int isSmooth;

fprintf(f,"/* Begin polygones */\n\n mesh {\n");
while(lst){
isSmooth= smooth&&CheckNormals(lst->points,lst->pno);
if(lst->pno>=3){
fprintf(f,"%s {\n",isSmooth?"smooth_triangle":"triangle");
for(i= 0;i<lst->pno;i++){
p= PointPool+(thisI= lst->points[i]);
WritePOVVector(f,"\t",p,"");
if(NormalPool[thisI]&&isSmooth)
WritePOVVector(f,", ",NormalPool[thisI],"");
fprintf(f,"%s",i==lst->pno-1?"\n":",\n");
}
fprintf(f,"}\n");
}
lst= lst->next;
}
if(TrackAngle!=0.0)
POVTrackballPosition(f);
fprintf(f,"}\n\n/* End polygones  */\n");
}

/*:123*/
#line 1835 "F:\Develop\mview3d\mathview3d.w"

/*117:*/
#line 1841 "F:\Develop\mview3d\mathview3d.w"

void ScaleToWorld(Point3D*pw,Point3D*p)
{
pw->x= CenterOfScene.x+MaxScaleOfScene*p->x;
pw->y= CenterOfScene.y+MaxScaleOfScene*p->y;
pw->z= CenterOfScene.z+MaxScaleOfScene*p->z;
}

/*:117*/
#line 1836 "F:\Develop\mview3d\mathview3d.w"

/*119:*/
#line 1855 "F:\Develop\mview3d\mathview3d.w"

void WriteLights(FILE*f,Point3D*lightp,RGBColor*lcolor,int n,int shaddow)
{Point3D ls;
int i;

for(i= 0;i<n;i++){
ScaleToWorld(&ls,lightp+i);
WritePOVVector(f,"light_source {\n\t",&ls,"\n");
WritePOVVector(f,"\tcolor rgb ",(Point3D*)(lcolor+i),"\n");
if(!shaddow)fprintf(f,"\tshadowless\n");
fprintf(f,"}\n\n");
}
}

/*:119*/
#line 1837 "F:\Develop\mview3d\mathview3d.w"

/*130:*/
#line 2082 "F:\Develop\mview3d\mathview3d.w"

void WritePOVProlog(FILE*f,const char*povname)
{Point3D vp,p;
Point3D addLight[8]= {{2,2,2},{-2,2,2},{-2,-2,2},{2,-2,2},
{2,2,-2},{-2,2,-2},{-2,-2,-2},{2,-2,-2}};
RGBColor addLColor[8]= {{0.25,0.25,0.25},
{0.25,0.25,0.25},{0.25,0.25,0.25},{0.25,0.25,0.25},
{0.1,0.1,0.1},{0.1,0.1,0.1},{0.1,0.1,0.1},{0.1,0.1,0.1}};
fprintf(f,"//**********************************************\n"
"//  File was created by "BANNER"\n// Version "VERSION"\n"
"// (c) by Jens-Peer Kuska 1997\n"
"//**********************************************\n");
fprintf(f,"// POVray 3.0 input file: %s     \n",povname);
if(*ThreeScriptName){
fprintf(f,"// 3Script source       : %s     \n",ThreeScriptName);
}
fprintf(f,"// Bounding box:\n"
"// x: %lg  %lg\n// y: %lg %lg\n// z: %lg %lg \n//\n",
BoundP1.x,BoundP2.x,BoundP1.y,BoundP2.y,BoundP1.z,BoundP2.z);
fprintf(f,"// Unique Points: %d\n",PoolSize);
fprintf(f,"// Line         : %ld\n",LengthLinePolyList(Lines));
fprintf(f,"// Polygons     : %ld\n",LengthLinePolyList(Polygons));

fprintf(f,"// end of header *******************************\n\n");
fprintf(f,"#default {"
"texture {"
"pigment { color <1, 1, 1>}"
"finish { phong 0.8 ambient 0.4}"
"}}\n");
if(AmbientColor.r>0.0||AmbientColor.g>0.0||AmbientColor.r>0.0)
fprintf(f,"global_settings { ambient_light color rgb <%lg, %lg, %lg>}\n\n",
AmbientColor.r,AmbientColor.g,AmbientColor.b);
ScaleToWorld(&vp,&ViewPoint);
p.x= p.z= 0.0;p.y= Norm(&vp);
fprintf(f,"camera {\n");

WritePOVVector(f,"\tlocation  ",&vp,"\n");
WritePOVVector(f,"\tdirection ",&p,"\n");
p.x= p.y= 0.0;p.z= Camera*MaxScaleOfScene;
WritePOVVector(f,"\tup        ",&p,"\n");
p.x= Camera*MaxScaleOfScene;p.y= p.z= 0.0;
WritePOVVector(f,"\tright     ",&p,"\n");
WritePOVVector(f,"\tsky       ",&ZAxis,"\n");
WritePOVVector(f,"\tlook_at   ",&CenterOfScene,"\n }\n\n");
WriteLights(f,LightPosition,LightColor,LightNo,GL_FALSE);
WriteLights(f,addLight,addLColor,8,GL_TRUE);
fprintf(f,"/* Graphics data begin */\n");
}


/*:130*/
#line 1838 "F:\Develop\mview3d\mathview3d.w"

/*131:*/
#line 2132 "F:\Develop\mview3d\mathview3d.w"

int WritePOVray(const char*povout,int smooth)
{FILE*f;

f= fopen(povout,"w");
if(!f)return 1;
WritePOVProlog(f,povout);
if(Points&&(0.0<PointSphereSize))
WritePOVPoints(f,Points);
if(Lines)
WritePOVLines(f,Lines);

if(Polygons)
WritePOVTriangles(f,Polygons,smooth);
fclose(f);
return 0;
}

/*:131*/
#line 1839 "F:\Develop\mview3d\mathview3d.w"


/*:116*/
#line 36 "F:\Develop\mview3d\mathview3d.w"

/*132:*/
#line 2152 "F:\Develop\mview3d\mathview3d.w"

/*138:*/
#line 2225 "F:\Develop\mview3d\mathview3d.w"

void WriteDXF3dFace(FILE*f,int layer,
int color,int*points,int pno)
{int i,k;

fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
fprintf(f,"62\n%d\n",color);
for(i= 0;i<pno;i++){
k= 1;
fprintf(f,"%d\n%lg\n",i+10*(k++),PointPool[points[i]].x);
fprintf(f,"%d\n%lg\n",i+10*(k++),PointPool[points[i]].y);
fprintf(f,"%d\n%lg\n",i+10*(k++),PointPool[points[i]].z);
}
}

/*:138*/
#line 2153 "F:\Develop\mview3d\mathview3d.w"

/*140:*/
#line 2261 "F:\Develop\mview3d\mathview3d.w"

int CheckTubeTetra(Point3D*p1,Point3D*p2,Point3D*p3,Point3D*p4,
Point3D*v1,Point3D*v2,Point3D*v3,Point3D*v4)
{Point3D n;
Point3D nn1,nn2;

n.x= 0.25*(v1->x+v2->x+v3->x+v4->x);
n.y= 0.25*(v1->y+v2->y+v3->y+v4->y);
n.z= 0.25*(v1->z+v2->z+v3->z+v4->z);
SurfaceNormal(&nn1,p4,p1,p2);
SurfaceNormal(&nn2,p2,p3,p4);
nn1.x+= nn2.x;nn1.y= nn2.y;nn1.z= nn2.z;
if(Dot(&nn1,&n)<0)return GL_FALSE;
return GL_TRUE;
}

/*:140*/
#line 2154 "F:\Develop\mview3d\mathview3d.w"

/*139:*/
#line 2241 "F:\Develop\mview3d\mathview3d.w"

void WriteDXFTriangle(FILE*f,int layer,
int color,Point3D*p1,Point3D*p2,Point3D*p3)
{
fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
fprintf(f,"62\n%d\n",color);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
10,p1->x,20,p1->y,30,p1->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
11,p2->x,21,p2->y,31,p2->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
12,p3->x,22,p3->y,32,p3->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
13,p1->x,23,p1->y,33,p1->z);
}

/*:139*/
#line 2155 "F:\Develop\mview3d\mathview3d.w"

/*141:*/
#line 2278 "F:\Develop\mview3d\mathview3d.w"

void WriteDXFTetra(FILE*f,int layer,
int color,Point3D*p1,Point3D*p2,Point3D*p3,Point3D*p4)
{
fprintf(f,"0\n3DFACE\n8\n%d\n",layer);
fprintf(f,"62\n%d\n",color);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
10,p1->x,20,p1->y,30,p1->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
11,p2->x,21,p2->y,31,p2->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
12,p3->x,22,p3->y,32,p3->z);
fprintf(f,"%d\n%lg\n%d\n%lg\n%d\n%lg\n",
13,p4->x,23,p4->y,33,p4->z);
}

/*:141*/
#line 2156 "F:\Develop\mview3d\mathview3d.w"

/*150:*/
#line 2449 "F:\Develop\mview3d\mathview3d.w"

void MakeDXFSphere(FILE*dxffile,
int layer,int color,Point3D*pnt,
double r,int nphi,int nth)
{double dth,dp;
int i,j;
double cp,cp1,st,st1,sp,sp1,ct,ct1,phi,th;
Point3D p,p1,p2,p3;

dp= TWO_PI/nphi;
dth= PI/nth;
for(i= 0;i<nphi;i++){
cp= cos(phi= i*dp);
sp= sin(phi);
cp1= cos(phi= (i+1)*dp);
sp1= sin(phi);
for(j= 0;j<nth;j++){
ct= r*cos(th= (j+1)*dth);
st= r*sin(th);
ct1= r*cos(th= j*dth);
st1= r*sin(th);
p.x= p1.x= p2.x= p3.x= pnt->x;
p.y= p1.y= p2.y= p3.y= pnt->y;
p.z= p1.z= p2.z= p3.z= pnt->z;
p.x+= cp*st;p.y+= sp*st;p.z+= ct;
p1.x+= cp1*st;p1.y+= sp1*st;p1.z+= ct;
p2.x+= cp1*st1;p2.y+= sp1*st1;p2.z+= ct1;
p3.x+= cp*st1;p3.y+= sp*st1;p3.z+= ct1;
WriteDXFTetra(dxffile,layer,color,&p,&p1,&p2,&p3);
}
}
}

/*:150*/
#line 2157 "F:\Develop\mview3d\mathview3d.w"

/*149:*/
#line 2435 "F:\Develop\mview3d\mathview3d.w"

void WriteDXFPoints(FILE*dxffile,int layer,int color,PointList*lst)
{
fprintf(dxffile,"999\nPoints\n");
while(lst){
MakeDXFSphere(dxffile,layer,color,PointPool+(lst->point),
lst->size*PointSphereSize,
PointSphereSegmentsPhi,
PointSphereSegmentsTheta);
lst= lst->next;
}

}

/*:149*/
#line 2158 "F:\Develop\mview3d\mathview3d.w"

/*143:*/
#line 2310 "F:\Develop\mview3d\mathview3d.w"

void MakeDXFCone(FILE*f,int layer,int color,
Point3D*p1,Point3D*p2,double r,int n)
{Point3D v1,v2,v3,vn[4],p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);

v1.x= p2->x-p1->x;
v1.y= p2->y-p1->y;
v1.z= p2->z-p1->z;

dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn[0]= vn[1]= *p;
IncPoint3D(p[0],(*p1))
AddPoint3D(p[1],p[0],v1)
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn[2]= p[2];
IncPoint3D(p[2],(*p1))
AddPoint3D(p[3],p[2],v1)
vn[3]= vn[2];
/*144:*/
#line 2346 "F:\Develop\mview3d\mathview3d.w"

if(CheckTubeTetra(p,p+1,p+3,p+2,vn,vn+1,vn+3,vn+2))
WriteDXFTetra(f,layer,color,p,p+1,p+3,p+2);
else
WriteDXFTetra(f,layer,color,p+2,p+3,p+1,p);

/*:144*/
#line 2340 "F:\Develop\mview3d\mathview3d.w"

p[0]= p[2];vn[0]= vn[2];
p[1]= p[3];vn[1]= vn[3];
}
}

/*:143*/
#line 2159 "F:\Develop\mview3d\mathview3d.w"

/*145:*/
#line 2352 "F:\Develop\mview3d\mathview3d.w"

void MakeDXFConeContinued(FILE*f,int layer,int color,
Point3D*p1,Point3D*p2,Point3D*p3,
double r,int n)
{Point3D v1,v2,v3,u1,u2,u3,vn[4],p[4];
double norm;
double dphi;
int i;

v1.x= p2->x-p1->x;v1.y= p2->y-p1->y;v1.z= p2->z-p1->z;
norm= Norm(&v1);
v1.x/= norm;v1.y/= norm;v1.z/= norm;
OrthogonalSet(&v1,&v2,&v3);
u1.x= p3->x-p2->x;u1.y= p3->y-p2->y;u1.z= p3->z-p2->z;
norm= Norm(&u1);
u1.x/= norm;u1.y/= norm;u1.z/= norm;
/*146:*/
#line 2391 "F:\Develop\mview3d\mathview3d.w"

if(Dot(&u1,&v1)<CosSkipCont){
MakeDXFCone(f,layer,color,p1,p2,r,n);
MakeDXFCone(f,layer,color,p2,p3,r,n);
return;
}

/*:146*/
#line 2368 "F:\Develop\mview3d\mathview3d.w"

u2= v2;u3= v3;
GramSchmidt(&u1,&u2,&u3);
dphi= TWO_PI/n;
ConePoint(r,0.0,&v2,&v3,p);
vn[0]= *p;
IncPoint3D(p[0],(*p1))
ConePoint(r,0.0,&u2,&u3,p+1);
vn[1]= p[1];
IncPoint3D(p[1],(*p2))
for(i= 1;i<=n;i++){
ConePoint(r,i*dphi,&v2,&v3,p+2);
vn[2]= p[2];
IncPoint3D(p[2],(*p1))
ConePoint(r,i*dphi,&u2,&u3,p+3);
vn[3]= p[3];
IncPoint3D(p[3],(*p2))
/*144:*/
#line 2346 "F:\Develop\mview3d\mathview3d.w"

if(CheckTubeTetra(p,p+1,p+3,p+2,vn,vn+1,vn+3,vn+2))
WriteDXFTetra(f,layer,color,p,p+1,p+3,p+2);
else
WriteDXFTetra(f,layer,color,p+2,p+3,p+1,p);

/*:144*/
#line 2385 "F:\Develop\mview3d\mathview3d.w"

p[0]= p[2];vn[0]= vn[2];
p[1]= p[3];vn[1]= vn[3];
}
}

/*:145*/
#line 2160 "F:\Develop\mview3d\mathview3d.w"

/*142:*/
#line 2294 "F:\Develop\mview3d\mathview3d.w"

void WriteDXFPolys(FILE*f,int layer,int color,LinePolyList*lst)
{
fprintf(f,"999\nPolygons\n");
while(lst){
if(3==lst->pno)
WriteDXFTriangle(f,layer,color,
PointPool+lst->points[0],
PointPool+lst->points[1],
PointPool+lst->points[2]);
else
WriteDXF3dFace(f,layer,color,lst->points,lst->pno);
lst= lst->next;
}
}

/*:142*/
#line 2161 "F:\Develop\mview3d\mathview3d.w"

/*147:*/
#line 2398 "F:\Develop\mview3d\mathview3d.w"

void WriteDXFLines(FILE*f,int layer,int color,LinePolyList*lst)
{int i;
fprintf(f,"999\nCovered lines\n");
while(lst){
/*148:*/
#line 2408 "F:\Develop\mview3d\mathview3d.w"

{if(2==lst->pno)
MakeDXFCone(f,layer,color,PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
else{
for(i= 0;i<lst->pno-2;i++)
MakeDXFConeContinued(f,layer,color,
PointPool+lst->points[i],
PointPool+lst->points[i+1],
PointPool+lst->points[i+2],
LineTubeSize,TubeSegments);
i= lst->pno-2;
if(lst->points[0]==lst->points[i+1]){
MakeDXFConeContinued(f,layer,color,
PointPool+lst->points[i],
PointPool+lst->points[0],
PointPool+lst->points[1],
LineTubeSize,TubeSegments);
}
else
MakeDXFCone(f,layer,color,PointPool+lst->points[i],
PointPool+lst->points[i+1],
LineTubeSize,TubeSegments);
}
}

/*:148*/
#line 2403 "F:\Develop\mview3d\mathview3d.w"

lst= lst->next;
}
}

/*:147*/
#line 2162 "F:\Develop\mview3d\mathview3d.w"

/*133:*/
#line 2166 "F:\Develop\mview3d\mathview3d.w"

int WriteDXF(char*dxfname)
{FILE*dxffile;

dxffile= fopen(dxfname,"w");
if(dxffile){
/*134:*/
#line 2200 "F:\Develop\mview3d\mathview3d.w"

fprintf(dxffile,"999\n"
"DXF created from mathview3d "VERSION
"\n0\n"
"SECTION\n2\n"
"HEADER\n0\nENDSEC\n");

fprintf(dxffile,"0\nSECTION\n2\nTABLES\n0\n"
"TABLE\n3\n"
"LAYER\n0\n"
"LAYER\n2\n1\n0\n"
"LAYER\n2\n2\n0\n"
"LAYER\n2\n3\n0\n"
"ENDTAB\n0\nENDSEC\n");

fprintf(dxffile,"0\nSECTION\n2\nBLOCKS\n0\nENDSEC\n");

/*:134*/
#line 2172 "F:\Develop\mview3d\mathview3d.w"

/*136:*/
#line 2219 "F:\Develop\mview3d\mathview3d.w"

fprintf(dxffile,"0\nSECTION\n2\nENTITIES\n");

/*:136*/
#line 2173 "F:\Develop\mview3d\mathview3d.w"


if(Polygons)
WriteDXFPolys(dxffile,POLY_LAYER,1,Polygons);
if(Lines&&LineTubeSize>0.0)
WriteDXFLines(dxffile,LINE_LAYER,2,Lines);
if(Points&&PointSphereSize>0.0)
WriteDXFPoints(dxffile,POINT_LAYER,3,Points);

/*137:*/
#line 2222 "F:\Develop\mview3d\mathview3d.w"

fprintf(dxffile,"0\nENDSEC\n");

/*:137*/
#line 2182 "F:\Develop\mview3d\mathview3d.w"

/*135:*/
#line 2217 "F:\Develop\mview3d\mathview3d.w"
fprintf(dxffile,"0\nEOF\n");

/*:135*/
#line 2183 "F:\Develop\mview3d\mathview3d.w"

fclose(dxffile);
return 0;
}
return 1;
}

/*:133*/
#line 2163 "F:\Develop\mview3d\mathview3d.w"



/*:132*/
#line 37 "F:\Develop\mview3d\mathview3d.w"

/*2:*/
#line 58 "F:\Develop\mview3d\mathview3d.w"

void MVDisplay(void){

if(MakeNewView){
glPopMatrix();
glPushMatrix();
glTranslated(ZoomMove.x,ZoomMove.y,ZoomMove.z);
MakeNewView= GL_FALSE;
}
if(MakeNewModel){
CreateObject();
MakeNewModel= GL_FALSE;
}
if(DoReset){
glPopMatrix();
glPushMatrix();
glTranslated(ZoomMove.x+CenterOfScene.x,
ZoomMove.y+CenterOfScene.y,
ZoomMove.z+CenterOfScene.z);
if(DoTracking)
glRotated(TrackAngle*ToDegree,TrackAxis.x,TrackAxis.y,TrackAxis.z);
glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);
if(DoReset)DoReset= GL_FALSE;
}
else if(DoTracking){
if(!DoTrackSpin&&GetMouseTrack){
MVTrackball(&TrackAngle,&TrackAxis,ScreenXStart,ScreenYStart,ScreenX,ScreenY);
DTrackAngle= MIN(TWO_PI/90.0,TrackAngle);
}
else
TrackAngle+= DTrackAngle;
}
if(TrackAngle){
/*3:*/
#line 99 "F:\Develop\mview3d\mathview3d.w"

glPopMatrix();
glPushMatrix();
glTranslated(ZoomMove.x+CenterOfScene.x,
ZoomMove.y+CenterOfScene.y,
ZoomMove.z+CenterOfScene.z);
glRotated(TrackAngle*ToDegree,TrackAxis.x,TrackAxis.y,TrackAxis.z);
glTranslated(-CenterOfScene.x,-CenterOfScene.y,-CenterOfScene.z);

/*:3*/
#line 91 "F:\Develop\mview3d\mathview3d.w"

}
glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
if(ObjID>0)
glCallList(ObjID);
glutSwapBuffers();
}

/*:2*/
#line 38 "F:\Develop\mview3d\mathview3d.w"

/*4:*/
#line 108 "F:\Develop\mview3d\mathview3d.w"

void MVAnimate(void)
{
if(MathLinkMode&&MathLinkActive){
if(!ProcessMathLink(&LinkToMath))exit(0);
}
if(DoTracking)
glutPostRedisplay();
}


/*:4*/
#line 39 "F:\Develop\mview3d\mathview3d.w"

/*5:*/
#line 119 "F:\Develop\mview3d\mathview3d.w"

void MVMouseButton(int btn,int state,int x,int y)
{
if(btn!=GLUT_LEFT_BUTTON||!DoTracking)return;
switch(state){
case GLUT_DOWN:
ScreenXStart= ScreenX= x;
ScreenYStart= ScreenY= y;
DoTrackSpin= GL_FALSE;
break;
case GLUT_UP:
ScreenX= x;
ScreenY= y;
DoTrackSpin= GL_TRUE;
break;
}
}

/*:5*/
#line 40 "F:\Develop\mview3d\mathview3d.w"

/*6:*/
#line 137 "F:\Develop\mview3d\mathview3d.w"

void MVMouseMove(int x,int y)
{
if(!DoTracking)return;
ScreenX= x;
ScreenY= y;
glutPostRedisplay();
}

/*:6*/
#line 41 "F:\Develop\mview3d\mathview3d.w"

/*7:*/
#line 146 "F:\Develop\mview3d\mathview3d.w"

void MVReshape(int w,int h)
{
glViewport(0,0,w,h);
ScreenWidth= w;
ScreenHeight= h;
}


/*:7*/
#line 42 "F:\Develop\mview3d\mathview3d.w"

/*23:*/
#line 427 "F:\Develop\mview3d\mathview3d.w"

void MVWinFileMenu(int what)
{
switch(what){
case MENU_ID_SAVEPOVRAY_SMOOTH:
WritePOVray("mview3ds.pov",GL_TRUE);
break;
case MENU_ID_SAVEPOVRAY_FLAT:
WritePOVray("mview3df.pov",GL_FALSE);
break;
case MENU_ID_SAVE_DXF:
WriteDXF("mview3d.dxf");
break;
}
glutPostRedisplay();
}

/*:23*/
#line 43 "F:\Develop\mview3d\mathview3d.w"

/*25:*/
#line 457 "F:\Develop\mview3d\mathview3d.w"

void MVWinSpinMenu(int what)
{
switch(what){
case MENU_ID_SPIN_TRACKBALL:
GetMouseTrack= GL_TRUE;
/*27:*/
#line 496 "F:\Develop\mview3d\mathview3d.w"

DoTracking= GL_TRUE;
DoTrackSpin= GL_FALSE;

/*:27*/
#line 463 "F:\Develop\mview3d\mathview3d.w"

break;

case MENU_ID_SPIN_X:
TrackAxis.x= 1.0;TrackAxis.y= TrackAxis.z= 0.0;
/*28:*/
#line 500 "F:\Develop\mview3d\mathview3d.w"

DoTrackSpin= DoTracking= GL_TRUE;
GetMouseTrack= GL_FALSE;
TrackAngle= 0.0;
DTrackAngle= TWO_PI/80.;


/*:28*/
#line 468 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_SPIN_Y:
TrackAxis.y= 1.0;TrackAxis.x= TrackAxis.z= 0.0;
/*28:*/
#line 500 "F:\Develop\mview3d\mathview3d.w"

DoTrackSpin= DoTracking= GL_TRUE;
GetMouseTrack= GL_FALSE;
TrackAngle= 0.0;
DTrackAngle= TWO_PI/80.;


/*:28*/
#line 472 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_SPIN_Z:
TrackAxis.z= 1.0;TrackAxis.x= TrackAxis.y= 0.0;
/*28:*/
#line 500 "F:\Develop\mview3d\mathview3d.w"

DoTrackSpin= DoTracking= GL_TRUE;
GetMouseTrack= GL_FALSE;
TrackAngle= 0.0;
DTrackAngle= TWO_PI/80.;


/*:28*/
#line 476 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_SPIN_SLOW:
DTrackAngle*= 0.5;
break;
case MENU_ID_SPIN_FAST:
DTrackAngle*= 2.0;
break;
case MENU_ID_STOP:
/*26:*/
#line 491 "F:\Develop\mview3d\mathview3d.w"

DoTrackSpin= GL_FALSE;
TrackAngle= 0.0;
DoTracking= GL_FALSE;

/*:26*/
#line 485 "F:\Develop\mview3d\mathview3d.w"

break;
}
glutPostRedisplay();
}

/*:25*/
#line 44 "F:\Develop\mview3d\mathview3d.w"

/*30:*/
#line 513 "F:\Develop\mview3d\mathview3d.w"

void MVWinAppearMenu(int what)
{
switch(what){
case MENU_ID_SHOW_SMOOTH:
SmoothShading= GL_TRUE;
WireFrame= GL_FALSE;
break;
case MENU_ID_SHOW_FLAT:
SmoothShading= GL_FALSE;
WireFrame= GL_FALSE;
break;
case MENU_ID_SHOW_WIRE:
WireFrame= GL_TRUE;
break;
}
MakeNewModel= GL_TRUE;
glutPostRedisplay();
}


/*:30*/
#line 45 "F:\Develop\mview3d\mathview3d.w"

/*19:*/
#line 348 "F:\Develop\mview3d\mathview3d.w"

void MVWinMainMenu(int what)
{double vr,vtheta,vphi;

switch(what){
case MENU_ID_RESET:
/*20:*/
#line 400 "F:\Develop\mview3d\mathview3d.w"

DoReset= GL_TRUE;
DoTracking= DoTrackSpin= GL_FALSE;
ZoomMove.x= ZoomMove.y= ZoomMove.z= 0.0;
RadialZoom= 1.0;
TrackAngle= 0.0;
TrackAxis.x= TrackAxis.y= 0.0;
TrackAxis.z= 1.0;
ScreenXStart= ScreenX= 0;
ScreenYStart= ScreenY= 0;

/*:20*/
#line 354 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_FLIP_FACE:
ReversePolygons(Polygons);
AveragedNormals(Polygons);
MakeNewModel= GL_TRUE;
break;
case MENU_ID_ZOOM_OUT:
RadialZoom*= 1.5;
/*21:*/
#line 411 "F:\Develop\mview3d\mathview3d.w"

SphericalFromCartesian(&ViewPoint,&vr,&vtheta,&vphi);
ZoomMove.x= ViewPoint.x-RadialZoom*vr*cos(vphi)*sin(vtheta);
ZoomMove.y= ViewPoint.y-RadialZoom*vr*sin(vphi)*sin(vtheta);
ZoomMove.z= ViewPoint.z-RadialZoom*vr*cos(vtheta);

MakeNewView= GL_TRUE;


/*:21*/
#line 363 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_ZOOM_IN:
RadialZoom/= 1.5;
/*21:*/
#line 411 "F:\Develop\mview3d\mathview3d.w"

SphericalFromCartesian(&ViewPoint,&vr,&vtheta,&vphi);
ZoomMove.x= ViewPoint.x-RadialZoom*vr*cos(vphi)*sin(vtheta);
ZoomMove.y= ViewPoint.y-RadialZoom*vr*sin(vphi)*sin(vtheta);
ZoomMove.z= ViewPoint.z-RadialZoom*vr*cos(vtheta);

MakeNewView= GL_TRUE;


/*:21*/
#line 367 "F:\Develop\mview3d\mathview3d.w"

break;
case MENU_ID_ABOUT:
printf(BANNER
" (c) Jens-Peer Kuska  Version "VERSION
"\nfor "ARCH"\ncompiled at "__DATE__"\n");
if(*ThreeScriptName)
printf("3Script file   : %s\n",ThreeScriptName);
printf("Screen         : %d x %d\n",ScreenWidth,ScreenHeight);
printf("Center         : {%lg, %lg, %lg}\n",
CenterOfScene.x,CenterOfScene.y,CenterOfScene.z);
printf("Scaling        : {%lg, %lg, %lg}\n",
ScaleOfScene.x,ScaleOfScene.y,ScaleOfScene.z);
if(ObjID>0)
printf("Compiled obj   : %d\n",ObjID);
if(PoolSize)
printf("Unique Points  : %d of %d\n",PoolSize,MaxPoolSize);
printf("Polygon number : %ld\n",LengthLinePolyList(Polygons));
printf("Line number    : %ld\n",LengthLinePolyList(Lines));
printf("Polygon shading: %s\n",SmoothShading?"smooth":"flat");
printf("Wire frame     : %s\n",WireFrame?"On":"Off");
printf("Tracking mode  : %s\n",DoTracking?"on":"off");
break;
case MENU_ID_CLEAR:
mvClearContents();
break;
case MENU_ID_QUIT:
exit(0);
break;
}
glutPostRedisplay();
}

/*:19*/
#line 46 "F:\Develop\mview3d\mathview3d.w"

/*18:*/
#line 322 "F:\Develop\mview3d\mathview3d.w"

void MVCreateMainMenu(void){

/*22:*/
#line 421 "F:\Develop\mview3d\mathview3d.w"

menuIDFiles= glutCreateMenu(MVWinFileMenu);
glutAddMenuEntry("Save as smooth POVRay file",MENU_ID_SAVEPOVRAY_SMOOTH);
glutAddMenuEntry("Save as flat POVRay file",MENU_ID_SAVEPOVRAY_FLAT);
glutAddMenuEntry("Save DXF file",MENU_ID_SAVE_DXF);

/*:22*/
#line 325 "F:\Develop\mview3d\mathview3d.w"

/*24:*/
#line 444 "F:\Develop\mview3d\mathview3d.w"

menuIDSpin= glutCreateMenu(MVWinSpinMenu);
glutAddMenuEntry("Trackball",MENU_ID_SPIN_TRACKBALL);
glutAddMenuEntry("X axes spin",MENU_ID_SPIN_X);
glutAddMenuEntry("Y axes spin",MENU_ID_SPIN_Y);
glutAddMenuEntry("Z axes spin",MENU_ID_SPIN_Z);
glutAddMenuEntry("Spin slower",MENU_ID_SPIN_SLOW);
glutAddMenuEntry("Spin faster",MENU_ID_SPIN_FAST);
glutAddMenuEntry("Halt",MENU_ID_STOP);




/*:24*/
#line 326 "F:\Develop\mview3d\mathview3d.w"

/*29:*/
#line 507 "F:\Develop\mview3d\mathview3d.w"

menuIDAppear= glutCreateMenu(MVWinAppearMenu);
glutAddMenuEntry("Smooth surface",MENU_ID_SHOW_SMOOTH);
glutAddMenuEntry("Flat surface",MENU_ID_SHOW_FLAT);
glutAddMenuEntry("Wire frame",MENU_ID_SHOW_WIRE);

/*:29*/
#line 327 "F:\Develop\mview3d\mathview3d.w"

/*29:*/
#line 507 "F:\Develop\mview3d\mathview3d.w"

menuIDAppear= glutCreateMenu(MVWinAppearMenu);
glutAddMenuEntry("Smooth surface",MENU_ID_SHOW_SMOOTH);
glutAddMenuEntry("Flat surface",MENU_ID_SHOW_FLAT);
glutAddMenuEntry("Wire frame",MENU_ID_SHOW_WIRE);

/*:29*/
#line 328 "F:\Develop\mview3d\mathview3d.w"

menuIDMain= glutCreateMenu(MVWinMainMenu);
glutAddSubMenu("Files...",menuIDFiles);
glutAddSubMenu("Spin...",menuIDSpin);
glutAddSubMenu("Appearence ...",menuIDAppear);
glutAddMenuEntry("Reset view",MENU_ID_RESET);
glutAddMenuEntry("Zoom out",MENU_ID_ZOOM_OUT);
glutAddMenuEntry("Zoom in",MENU_ID_ZOOM_IN);
glutAddMenuEntry("Flip faces",MENU_ID_FLIP_FACE);
if(!MathLinkMode){
glutAddMenuEntry("About",MENU_ID_ABOUT);
glutAddMenuEntry("Quit",MENU_ID_QUIT);
}
else
glutAddMenuEntry("Clear Window",MENU_ID_CLEAR);

glutAttachMenu(GLUT_RIGHT_BUTTON);
}

/*:18*/
#line 47 "F:\Develop\mview3d\mathview3d.w"

/*31:*/
#line 535 "F:\Develop\mview3d\mathview3d.w"

void MathViewExit(void)
{int i;
if(PointPool)free(PointPool);
if(NormalPool)
for(i= 0;i<PoolSize;i++)
if(NormalPool[i])free(NormalPool[i]);
free(NormalPool);
Points= RemovePointList(Points);
Lines= RemoveLinePolyList(Lines);
Polygons= RemoveLinePolyList(Polygons);
if(MathLinkMode){
/*231:*/
#line 3571 "F:\Develop\mview3d\mathview3d.w"

if(LinkToMath)
MLClose(LinkToMath);
MLDeinitialize(stdenv);
stdenv= (MLEnvironment)0;
exit(!MLDone);


/*:231*/
#line 547 "F:\Develop\mview3d\mathview3d.w"

}
}

/*:31*/
#line 48 "F:\Develop\mview3d\mathview3d.w"

/*196:*/
#line 3069 "F:\Develop\mview3d\mathview3d.w"

/*234:*/
#line 3604 "F:\Develop\mview3d\mathview3d.w"

int IsMathLinkCall(int argc,char*argv[])
{int i;

for(i= 0;i<argc;i++){
if(strcmp(argv[i],"-mathlink")==0)return GL_TRUE;
if(strcmp(argv[i],"-linkname")==0)return GL_TRUE;
if(strcmp(argv[i],"-linkmode")==0)return GL_TRUE;
if(strcmp(argv[i],"-linkcreate")==0)return GL_TRUE;
if(strcmp(argv[i],"-linkprotocol")==0)return GL_TRUE;
}
return GL_FALSE;
}

/*:234*/
#line 3070 "F:\Develop\mview3d\mathview3d.w"

/*233:*/
#line 3582 "F:\Develop\mview3d\mathview3d.w"

int ProcessMathLink(MLINK*mlp)
{int pkt;

if(MLDone&&MLError(*mlp)){
return 0;
}
while(MLReady(*mlp)&&!MLDone){
pkt= MLNextPacket(*mlp);
MLAbort= 0;
if(RESUMEPKT==pkt){
if(!refuse_to_be_a_frontend(*mlp))return 0;
/*231:*/
#line 3571 "F:\Develop\mview3d\mathview3d.w"

if(LinkToMath)
MLClose(LinkToMath);
MLDeinitialize(stdenv);
stdenv= (MLEnvironment)0;
exit(!MLDone);


/*:231*/
#line 3594 "F:\Develop\mview3d\mathview3d.w"

}
if(pkt!=CALLPKT||!MLDoCallPacket(*mlp))return 0;
MLFlush(*mlp);
MLAbort= 0;
}
return 1;
}


/*:233*/
#line 3071 "F:\Develop\mview3d\mathview3d.w"

/*220:*/
#line 3385 "F:\Develop\mview3d\mathview3d.w"

void GetGraphics3D(MLINK link,const char*head,long int count)
{long ecount,n,coord,coord1,nlen,i;
int k,j,plBuffer[2048];
double*v,vec[3],vec1[3];
int cubep[8];
const char*fhead;
double red,green,blue,sred,sgreen,sblue,dummy;
double psize,thickness;

fhead= head;
ecount= count;
n= ecount;
red= green= blue= sred= sgreen= sblue= 1.0;
psize= thickness= 0.001;
for(i= 0;i<ecount;i++){
/*221:*/
#line 3448 "F:\Develop\mview3d\mathview3d.w"

while(!MLReady(link)){
#ifdef __WIN32__
Sleep(100);
#else
usleep(100);
#endif
}

/*:221*/
#line 3401 "F:\Develop\mview3d\mathview3d.w"

MLGetFunction(link,&fhead,&n);
if(0==strcmp(fhead,"Polygon")){
/*222:*/
#line 3457 "F:\Develop\mview3d\mathview3d.w"

MLCheckFunction(link,"List",&n);
for(k= j= 0;j<n;j++){
/*221:*/
#line 3448 "F:\Develop\mview3d\mathview3d.w"

while(!MLReady(link)){
#ifdef __WIN32__
Sleep(100);
#else
usleep(100);
#endif
}

/*:221*/
#line 3460 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(link,&v,&coord);
if(3==coord){
plBuffer[k++]= AddToPointPool(v[0],v[1],v[2]);
}
MLDisownRealList(link,v,coord);
}
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,k,sred,sgreen,sblue);

/*:222*/
#line 3404 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"Line")){
/*223:*/
#line 3469 "F:\Develop\mview3d\mathview3d.w"

MLCheckFunction(link,"List",&n);
for(k= j= 0;j<n;j++){
/*221:*/
#line 3448 "F:\Develop\mview3d\mathview3d.w"

while(!MLReady(link)){
#ifdef __WIN32__
Sleep(100);
#else
usleep(100);
#endif
}

/*:221*/
#line 3472 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(link,&v,&coord);
if(3==coord){
plBuffer[k++]= AddToPointPool(v[0],v[1],v[2]);
}
MLDisownRealList(link,v,coord);
}
Lines= PrependLinePolyList(Lines,Line3D,plBuffer,k,red,green,blue);

/*:223*/
#line 3407 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"Point")){
/*224:*/
#line 3481 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(link,&v,&coord);
if(3==coord){
k= AddToPointPool(v[0],v[1],v[2]);
Points= PrependPointList(Points,k,psize,red,green,blue);
}
MLDisownRealList(link,v,coord);

/*:224*/
#line 3410 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"RGBColor")){
/*226:*/
#line 3529 "F:\Develop\mview3d\mathview3d.w"

MLGetReal(link,&red);
MLGetReal(link,&green);
MLGetReal(link,&blue);

/*:226*/
#line 3413 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"SurfaceColor")){
/*227:*/
#line 3534 "F:\Develop\mview3d\mathview3d.w"

if(MLCheckFunction(link,"RGBColor",&n)){
MLGetReal(link,&sred);
MLGetReal(link,&sgreen);
MLGetReal(link,&sblue);
}


/*:227*/
#line 3416 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"PointSize")){
MLGetReal(link,&psize);
}
else if(0==strcmp(fhead,"Cuboid")){
/*225:*/
#line 3489 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(link,&v,&coord);
vec[0]= v[0];vec[1]= v[1];vec[2]= v[2];
MLDisownRealList(link,v,coord);
if(2==n){
MLGetRealList(link,&v,&coord1);
vec1[0]= v[0];vec1[1]= v[1];vec1[2]= v[2];
MLDisownRealList(link,v,coord1);
}
else{
vec1[0]= vec[0]+1.0;vec1[1]= vec[1]+1.0;vec1[2]= vec[2]+1.0;
coord1= 3;
}
if(3==coord&&3==coord1){
plBuffer[3]= cubep[0]= AddToPointPool(vec[0],vec[1],vec[2]);
plBuffer[2]= cubep[1]= AddToPointPool(vec1[0],vec[1],vec[2]);
plBuffer[1]= cubep[2]= AddToPointPool(vec1[0],vec1[1],vec[2]);
plBuffer[0]= cubep[3]= AddToPointPool(vec[0],vec1[1],vec[2]);
plBuffer[4]= cubep[4]= AddToPointPool(vec[0],vec[1],vec1[2]);
plBuffer[5]= cubep[5]= AddToPointPool(vec1[0],vec[1],vec1[2]);
plBuffer[6]= cubep[6]= AddToPointPool(vec1[0],vec1[1],vec1[2]);
plBuffer[7]= cubep[7]= AddToPointPool(vec[0],vec1[1],vec1[2]);
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer+4,4,sred,sgreen,sblue);
plBuffer[0]= cubep[0];plBuffer[1]= cubep[1];
plBuffer[2]= cubep[5];plBuffer[3]= cubep[4];
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
plBuffer[0]= cubep[1];plBuffer[1]= cubep[2];
plBuffer[2]= cubep[6];plBuffer[3]= cubep[5];
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
plBuffer[0]= cubep[2];plBuffer[1]= cubep[3];
plBuffer[2]= cubep[7];plBuffer[3]= cubep[6];
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);
plBuffer[0]= cubep[3];plBuffer[1]= cubep[0];
plBuffer[2]= cubep[4];plBuffer[3]= cubep[7];
Polygons= PrependLinePolyList(Polygons,Polygon3D,plBuffer,4,sred,sgreen,sblue);

}


/*:225*/
#line 3422 "F:\Develop\mview3d\mathview3d.w"

}
else if(0==strcmp(fhead,"EdgeForm")){
if(n)
MLGetReal(link,&dummy);
}
else if(0==strcmp(fhead,"Thickness")){
MLGetReal(link,&dummy);
}
else if(0==strcmp(fhead,"List")){
GetGraphics3D(link,fhead,n);
}
else{
MLDisownSymbol(link,fhead);
MLGetNext(link);
continue;
}
MLDisownSymbol(link,fhead);
}

}

/*:220*/
#line 3072 "F:\Develop\mview3d\mathview3d.w"

/*212:*/
#line 3278 "F:\Develop\mview3d\mathview3d.w"

void mvPutGraphics3D(void)
{long int arglen,n;
int shade;
double*vec;
const char*head;
long int count;

if(MLCheckFunction(stdlink,"List",&arglen)){
/*216:*/
#line 3352 "F:\Develop\mview3d\mathview3d.w"

if(!MLCheckFunction(stdlink,"List",&n)){
MLPutSymbol(stdlink,"$Failed");
return;
}
else{
MLGetRealList(stdlink,&vec,&n);
memcpy((void*)&BoundP1,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);
MLGetRealList(stdlink,&vec,&n);
memcpy((void*)&BoundP2,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);
}

/*:216*/
#line 3287 "F:\Develop\mview3d\mathview3d.w"

/*217:*/
#line 3366 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(stdlink,&vec,&n);
memcpy((void*)&ViewPoint,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

/*:217*/
#line 3288 "F:\Develop\mview3d\mathview3d.w"

/*218:*/
#line 3371 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(stdlink,&vec,&n);
LightNo= n/3;
memcpy((void*)LightPosition,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);
MLGetRealList(stdlink,&vec,&n);
memcpy((void*)LightColor,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

/*:218*/
#line 3289 "F:\Develop\mview3d\mathview3d.w"

/*219:*/
#line 3380 "F:\Develop\mview3d\mathview3d.w"

MLGetRealList(stdlink,&vec,&n);
memcpy((void*)&AmbientColor,vec,n*sizeof(double));
MLDisownRealList(stdlink,vec,n);

/*:219*/
#line 3290 "F:\Develop\mview3d\mathview3d.w"

MLGetDouble(stdlink,&PointSphereSize);
MLGetDouble(stdlink,&LineTubeSize);
MLGetDouble(stdlink,&LineSegmentAngle);
/*12:*/
#line 233 "F:\Develop\mview3d\mathview3d.w"

CosSkipCont= cos(ToRadian*(fabs(LineSegmentAngle)<MaxLSAngle?LineSegmentAngle:MaxLSAngle));

/*:12*/
#line 3294 "F:\Develop\mview3d\mathview3d.w"

MLGetInteger(stdlink,&shade);
MLGetInteger(stdlink,&TubeSegments);
switch(shade){
case 1:
SmoothShading= GL_TRUE;
WireFrame= GL_FALSE;
break;
case 2:
SmoothShading= GL_FALSE;
WireFrame= GL_FALSE;
break;
case 3:
SmoothShading= GL_FALSE;
WireFrame= GL_TRUE;
break;
}
MLCheckFunction(stdlink,head,&count);
GetGraphics3D(stdlink,head,count);
}
else{
MLPutSymbol(stdlink,"$Failed");
return;
}
MLPutFunction(stdlink,"List",3L);
/*213:*/
#line 3328 "F:\Develop\mview3d\mathview3d.w"

MLPutFunction(stdlink,"Rule",2L);
MLPutSymbol(stdlink,"PlotRange");
MLPutList(3L);
MLPutList(2L);
MLPutReal(stdlink,BoundP1.x);
MLPutReal(stdlink,BoundP2.x);
MLPutList(2L);
MLPutReal(stdlink,BoundP1.y);
MLPutReal(stdlink,BoundP2.y);
MLPutList(2L);
MLPutReal(stdlink,BoundP1.z);
MLPutReal(stdlink,BoundP2.z);

/*:213*/
#line 3319 "F:\Develop\mview3d\mathview3d.w"

/*214:*/
#line 3342 "F:\Develop\mview3d\mathview3d.w"

MLPutFunction(stdlink,"Rule",2L);
MLPutSymbol(stdlink,"ViewPoint");
MLPutRealList(stdlink,&ViewPoint.x,3L);

/*:214*/
#line 3320 "F:\Develop\mview3d\mathview3d.w"

/*215:*/
#line 3347 "F:\Develop\mview3d\mathview3d.w"

MLPutFunction(stdlink,"Rule",2L);
MLPutSymbol(stdlink,"AmbientLight");
MLPutRealList(stdlink,&AmbientColor.r,3L);

/*:215*/
#line 3321 "F:\Develop\mview3d\mathview3d.w"

if(Polygons)AveragedNormals(Polygons);
InitView();
MakeNewModel= GL_TRUE;
glutPostRedisplay();
}

/*:212*/
#line 3073 "F:\Develop\mview3d\mathview3d.w"

/*199:*/
#line 3095 "F:\Develop\mview3d\mathview3d.w"

void mvClearContents(void)
{int i;
if(PointPool)free(PointPool);
PointPool= NULL;
if(NormalPool)
for(i= 0;i<PoolSize;i++)
if(NormalPool[i])free(NormalPool[i]);
if(NormalPool)free(NormalPool);
NormalPool= NULL;
MaxPoolSize= PoolSize= 0;
Points= RemovePointList(Points);
Lines= RemoveLinePolyList(Lines);
Polygons= RemoveLinePolyList(Polygons);
glDeleteLists(ObjID,1);
ObjID= -1;
DoTracking= DoTrackSpin= GL_FALSE;
ZoomMove.x= ZoomMove.y= ZoomMove.z= 0.0;
RadialZoom= 1.0;
TrackAngle= 0.0;
TrackAxis.x= TrackAxis.y= 0.0;
TrackAxis.z= 1.0;
ScreenXStart= ScreenX= 0;
ScreenYStart= ScreenY= 0;

InitView();
CreateObject();
/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3122 "F:\Develop\mview3d\mathview3d.w"

}

/*:199*/
#line 3074 "F:\Develop\mview3d\mathview3d.w"

/*206:*/
#line 3167 "F:\Develop\mview3d\mathview3d.w"

void mvSpin(double angle,double*axis,long int n)
{double atrack;

if(3!=n){
MLPutSymbol(stdlink,"$Failed");
return;
}
TrackAxis.x= axis[0];TrackAxis.y= axis[1];TrackAxis.z= axis[2];
atrack= Norm(&TrackAxis);
if(atrack!=0.0){
TrackAxis.x/= atrack;
TrackAxis.y/= atrack;
TrackAxis.z/= atrack;
}
else{
MLPutSymbol(stdlink,"$Failed");
return;
}
TrackAngle= angle;
if(TrackAngle>0.0)
DTrackAngle= MIN(TWO_PI/90.0,TrackAngle);
else
DTrackAngle= MAX(-TWO_PI/90.0,TrackAngle);
DoTrackSpin= GL_TRUE;
DoTracking= GL_TRUE;
GetMouseTrack= GL_FALSE;
MLPutSymbol(stdlink,"Null");
}

/*:206*/
#line 3075 "F:\Develop\mview3d\mathview3d.w"

/*207:*/
#line 3197 "F:\Develop\mview3d\mathview3d.w"

void mvStopSpin(void)
{
/*26:*/
#line 491 "F:\Develop\mview3d\mathview3d.w"

DoTrackSpin= GL_FALSE;
TrackAngle= 0.0;
DoTracking= GL_FALSE;

/*:26*/
#line 3200 "F:\Develop\mview3d\mathview3d.w"

/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3201 "F:\Develop\mview3d\mathview3d.w"

}

/*:207*/
#line 3076 "F:\Develop\mview3d\mathview3d.w"

/*197:*/
#line 3086 "F:\Develop\mview3d\mathview3d.w"

int mvGetPoolSize(void)
{
return PoolSize;
}

/*:197*/
#line 3077 "F:\Develop\mview3d\mathview3d.w"

/*209:*/
#line 3207 "F:\Develop\mview3d\mathview3d.w"

void mlWritePOVray(const char*fname,int smooth,
double ts,int tseg,double pssize,double tangle)
{int res;
double tsSave,psSave,cosaSave;
int tsegSave;
char filename[512];
int i,j,n;

tsSave= LineTubeSize;
LineTubeSize= ts;
tsegSave= TubeSegments;
TubeSegments= tseg;
psSave= PointSphereSize;
PointSphereSize= pssize;
cosaSave= CosSkipCont;
CosSkipCont= cos(ToRadian*(fabs(tangle)<MaxLSAngle?tangle:MaxLSAngle));

smooth= smooth>1?GL_FALSE:GL_TRUE;
/*210:*/
#line 3238 "F:\Develop\mview3d\mathview3d.w"

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
filename[j++]= fname[i];
else if(fname[++i]=='\\')
filename[j++]= '\\';
filename[j++]= fname[n];filename[j+1]= '\0';

/*:210*/
#line 3226 "F:\Develop\mview3d\mathview3d.w"

res= WritePOVray(filename,smooth);
LineTubeSize= tsSave;
TubeSegments= tsegSave;
PointSphereSize= psSave;
CosSkipCont= cosaSave;
if(res)
MLPutSymbol(stdlink,"$Failed");
else
MLPutString(stdlink,fname);
}

/*:209*/
#line 3078 "F:\Develop\mview3d\mathview3d.w"

/*211:*/
#line 3247 "F:\Develop\mview3d\mathview3d.w"

void mlWriteDXF(const char*fname,
double ts,int tseg,double pssize,double tangle)
{int res;
double tsSave,psSave,cosaSave;
int tsegSave;
char filename[512];
int i,j,n;

tsSave= LineTubeSize;
LineTubeSize= ts;
tsegSave= TubeSegments;
TubeSegments= tseg;
psSave= PointSphereSize;
PointSphereSize= pssize;
cosaSave= CosSkipCont;
CosSkipCont= cos(ToRadian*(fabs(tangle)<MaxLSAngle?tangle:MaxLSAngle));
/*210:*/
#line 3238 "F:\Develop\mview3d\mathview3d.w"

n= strlen(fname);
for(j= i= 0;i<n;i++)
if(fname[i]!='\\')
filename[j++]= fname[i];
else if(fname[++i]=='\\')
filename[j++]= '\\';
filename[j++]= fname[n];filename[j+1]= '\0';

/*:210*/
#line 3264 "F:\Develop\mview3d\mathview3d.w"

res= WriteDXF(filename);
LineTubeSize= tsSave;
TubeSegments= tsegSave;
PointSphereSize= psSave;
CosSkipCont= cosaSave;
if(res)
MLPutSymbol(stdlink,"$Failed");
else
MLPutString(stdlink,fname);
MLEndPacket(stdlink);
}

/*:211*/
#line 3079 "F:\Develop\mview3d\mathview3d.w"

/*200:*/
#line 3125 "F:\Develop\mview3d\mathview3d.w"

void mvReset(void)
{
/*20:*/
#line 400 "F:\Develop\mview3d\mathview3d.w"

DoReset= GL_TRUE;
DoTracking= DoTrackSpin= GL_FALSE;
ZoomMove.x= ZoomMove.y= ZoomMove.z= 0.0;
RadialZoom= 1.0;
TrackAngle= 0.0;
TrackAxis.x= TrackAxis.y= 0.0;
TrackAxis.z= 1.0;
ScreenXStart= ScreenX= 0;
ScreenYStart= ScreenY= 0;

/*:20*/
#line 3128 "F:\Develop\mview3d\mathview3d.w"

/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3129 "F:\Develop\mview3d\mathview3d.w"

}

/*:200*/
#line 3080 "F:\Develop\mview3d\mathview3d.w"

/*204:*/
#line 3153 "F:\Develop\mview3d\mathview3d.w"

void mvZoom(double zoom)
{double vr,vphi,vtheta;

RadialZoom*= zoom;
/*21:*/
#line 411 "F:\Develop\mview3d\mathview3d.w"

SphericalFromCartesian(&ViewPoint,&vr,&vtheta,&vphi);
ZoomMove.x= ViewPoint.x-RadialZoom*vr*cos(vphi)*sin(vtheta);
ZoomMove.y= ViewPoint.y-RadialZoom*vr*sin(vphi)*sin(vtheta);
ZoomMove.z= ViewPoint.z-RadialZoom*vr*cos(vtheta);

MakeNewView= GL_TRUE;


/*:21*/
#line 3158 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutDouble(stdlink,RadialZoom);
}

/*:204*/
#line 3081 "F:\Develop\mview3d\mathview3d.w"

/*201:*/
#line 3132 "F:\Develop\mview3d\mathview3d.w"

void mvShowWindow(void)
{
glutShowWindow();
/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3136 "F:\Develop\mview3d\mathview3d.w"

}

/*:201*/
#line 3082 "F:\Develop\mview3d\mathview3d.w"

/*202:*/
#line 3139 "F:\Develop\mview3d\mathview3d.w"

void mvHideWindow(void)
{
glutHideWindow();
/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3143 "F:\Develop\mview3d\mathview3d.w"

}

/*:202*/
#line 3083 "F:\Develop\mview3d\mathview3d.w"

/*203:*/
#line 3146 "F:\Develop\mview3d\mathview3d.w"

void mvIconifyWindow(void)
{
glutIconifyWindow();
/*205:*/
#line 3163 "F:\Develop\mview3d\mathview3d.w"

glutPostRedisplay();
MLPutSymbol(stdlink,"Null");

/*:205*/
#line 3150 "F:\Develop\mview3d\mathview3d.w"

}

/*:203*/
#line 3084 "F:\Develop\mview3d\mathview3d.w"


/*:196*/
#line 49 "F:\Develop\mview3d\mathview3d.w"

/*35:*/
#line 562 "F:\Develop\mview3d\mathview3d.w"

#ifdef __WIN32__
#pragma argsused
int PASCAL WinMain(HINSTANCE hCurInstance,
HINSTANCE hPrevInstance,
LPSTR lpCmdLine,int nCmdShow){
char*argv[32];
int argc,i;
char**argv_end= argv+32;
char buff[512];
char*buff_start= buff;
#else
int main(int argc,char*argv[]){
#endif
CmdArgLst*cmdln;
long int err;
void MathViewExit(void);
#ifdef __WIN32__
MLScanString(argv,&argv_end,&lpCmdLine,&buff_start);
argc= argv_end-argv;
for(i= argc;i>0;i--)
argv[i]= argv[i-1];
argv[0]= "mathview3d";
argc++;
#endif
/*10:*/
#line 185 "F:\Develop\mview3d\mathview3d.w"

cmdln= DeclareCmdArg("mvfile",CMD_STRING,&ThreeScriptName,"       3Script input file.");
cmdln= AppendCmdArg(DeclareCmdArg("mvs",CMD_SWITCH,&SmoothShading,
"shows smooth/flat input data"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvw",CMD_SWITCH,&WireFrame,
"show data as WireFrame"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvo",CMD_SWITCH,&PolyOutline,
"show polygon outline"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvct",CMD_SWITCH,&COMTriangulation,
"triangulate n-gons (n>4) with a new point in the center"),cmdln);

cmdln= AppendCmdArg(DeclareCmdArg("mvts",CMD_DOUBLE,&LineTubeSize,
"tube size of lines -- if given lines appear as tubes"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvta",CMD_DOUBLE,&LineSegmentAngle,
"maximum angle for smooth line continuation"),cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvps",CMD_DOUBLE,&PointSphereSize,
"sphere size of points -- if given points appear as spheres"),cmdln);
cmdln= AppendCmdArg(
DeclareCmdArg("mvpov",CMD_STRING,&POVOutName,"       POVRay output file."),
cmdln);
cmdln= AppendCmdArg(
DeclareCmdArg("mvdxf",CMD_STRING,&DXFOutName,"       DXF output file."),
cmdln);
cmdln= AppendCmdArg(DeclareCmdArg("mvno",CMD_SWITCH,&NoDisplay,
"run as filter and do not display the 3Script"),cmdln);

/*:10*/
#line 587 "F:\Develop\mview3d\mathview3d.w"

atexit(MathViewExit);
/*11:*/
#line 211 "F:\Develop\mview3d\mathview3d.w"

if(argc<=1){
HelpCmdArg(BANNER,cmdln);
return 1;
}
cmdln= ScanCommandline(cmdln,argc,argv);
if(*ThreeScriptName){
Scan3ScriptFile(ThreeScriptName);
AveragedNormals(Polygons);
}
/*12:*/
#line 233 "F:\Develop\mview3d\mathview3d.w"

CosSkipCont= cos(ToRadian*(fabs(LineSegmentAngle)<MaxLSAngle?LineSegmentAngle:MaxLSAngle));

/*:12*/
#line 221 "F:\Develop\mview3d\mathview3d.w"

MathLinkMode= IsMathLinkCall(argc,argv);
/*230:*/
#line 3550 "F:\Develop\mview3d\mathview3d.w"

if(MathLinkMode){
if(!stdenv)
stdenv= MLInitialize((MLParametersPointer)0);
if(stdenv==(MLEnvironment)0)
return!MLDone;
if(!stdhandler)
stdhandler= MLCreateMessageHandler(stdenv,MLDefaultHandler,0);
LinkToMath= MLOpenArgv(stdenv,argv,argv+argc,&err);
if(LinkToMath==(MLINK)0){
MLAlert(stdenv,MLErrorString(stdenv,err));
/*231:*/
#line 3571 "F:\Develop\mview3d\mathview3d.w"

if(LinkToMath)
MLClose(LinkToMath);
MLDeinitialize(stdenv);
stdenv= (MLEnvironment)0;
exit(!MLDone);


/*:231*/
#line 3561 "F:\Develop\mview3d\mathview3d.w"

}
if(stdhandler)MLSetMessageHandler(LinkToMath,stdhandler);
if(!MLInstall(LinkToMath)){
/*231:*/
#line 3571 "F:\Develop\mview3d\mathview3d.w"

if(LinkToMath)
MLClose(LinkToMath);
MLDeinitialize(stdenv);
stdenv= (MLEnvironment)0;
exit(!MLDone);


/*:231*/
#line 3565 "F:\Develop\mview3d\mathview3d.w"

}
MathLinkActive= GL_TRUE;
}


/*:230*/
#line 223 "F:\Develop\mview3d\mathview3d.w"

if(*ThreeScriptName&&*POVOutName)
WritePOVray(POVOutName,SmoothShading);
if(*ThreeScriptName&&*DXFOutName)
WriteDXF(DXFOutName);
if(NoDisplay){
cmdln= RemoveCmdArgs(cmdln);
return 0;
}

/*:11*/
#line 589 "F:\Develop\mview3d\mathview3d.w"

/*34:*/
#line 556 "F:\Develop\mview3d\mathview3d.w"

#if defined(__WIN32__) && defined(__BORLANDC__)
_control87(MCW_EM,MCW_EM);
#endif


/*:34*/
#line 590 "F:\Develop\mview3d\mathview3d.w"

glutInit(&argc,argv);
cmdln= RemoveCmdArgs(cmdln);
glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
glutCreateWindow(BANNER);
MVCreateMainMenu();
glutMouseFunc(MVMouseButton);
glutMotionFunc(MVMouseMove);
glutDisplayFunc(MVDisplay);
glutReshapeFunc(MVReshape);
glutIdleFunc(MVAnimate);
InitView();
glutMainLoop();
return 0;
}

/*:35*/
#line 50 "F:\Develop\mview3d\mathview3d.w"

/*152:*/
#line 2485 "F:\Develop\mview3d\mathview3d.w"

:Begin:
:Function: mvGetPoolSize  
:Pattern: MViewPoolSize[] 
:Arguments: {}            
:ArgumentTypes: {}        
:ReturnType: Integer      
:End:

/*:152*//*154:*/
#line 2498 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvPutGraphics3D 
:Pattern: MVPutGraphics3D[l_List] 
:Arguments:{l}                    
:ArgumentTypes: {Manual}          
:ReturnType: Manual               
:End:

/*:154*//*156:*/
#line 2510 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvClearContents 
:Pattern: MVClear[]       
:Arguments: {}            
:ArgumentTypes: {}        
:ReturnType: Manual       
:End:

/*:156*//*158:*/
#line 2522 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvReset 
:Pattern: MVReset[]       
:Arguments: {}            
:ArgumentTypes: {}        
:ReturnType: Manual       
:End:

/*:158*//*160:*/
#line 2534 "F:\Develop\mview3d\mathview3d.w"

:Begin:
:Function: mvShowWindow  
:Pattern: MVShowWindow[] 
:Arguments: {}           
:ArgumentTypes: {}       
:ReturnType: Manual      
:End:

/*:160*//*162:*/
#line 2546 "F:\Develop\mview3d\mathview3d.w"

:Begin:
:Function: mvHideWindow  
:Pattern: MVHideWindow[] 
:Arguments: {}           
:ArgumentTypes: {}       
:ReturnType: Manual      
:End:

/*:162*//*164:*/
#line 2558 "F:\Develop\mview3d\mathview3d.w"

:Begin:
:Function: mvIconifyWindow  
:Pattern: MVIconifyWindow[] 
:Arguments: {}           
:ArgumentTypes: {}       
:ReturnType: Manual      
:End:

/*:164*//*166:*/
#line 2570 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvStopSpin 
:Pattern: MVStopSpin[]       
:Arguments: {}            
:ArgumentTypes: {}        
:ReturnType: Manual       
:End:

/*:166*//*168:*/
#line 2582 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvZoom             
:Pattern: MVZoom[zoom_Real]   
:Arguments: {zoom}            
:ArgumentTypes: {Real}        
:ReturnType: Manual           
:End:

/*:168*//*170:*/
#line 2594 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mvSpin                                                  
:Pattern: MVSpin[angle_Real,l_ /;                                  
            VectorQ[l,Real==Head[#] &] && 3==Length[l]]            
:Arguments: {angle,l}                                              
:ArgumentTypes:{Real,RealList}                                     
:ReturnType: Manual                                                
:End: 

/*:170*//*171:*/
#line 2604 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: MVSpin[angle_?NumericQ,{x_?NumericQ,y_NumericQ,z_NumericQ}]:= 
             MVSpin[N[angle],N[{x,y,z}]] /. 0->0.0                    

/*:171*//*173:*/
#line 2612 "F:\Develop\mview3d\mathview3d.w"

:Begin: 
:Function: mlWritePOVray                                  
:Pattern: mvWritePOVRay[fname_String,smooth_Integer,      
             ts_Real,tseg_Integer,psize_Real,tangle_Real] 
:Arguments: {fname,smooth,ts,tseg,psize,tangle}           
:ArgumentTypes: {String,Integer,Real,Integer,Real,Real}   
:ReturnType: Manual                                       
:End:                                                     

/*:173*//*175:*/
#line 2625 "F:\Develop\mview3d\mathview3d.w"

:Begin:
:Function: mlWriteDXF                                      
:Pattern: mvWriteDXF[fname_String,                         
            ts_Real,tseg_Integer,psize_Real,tangle_Real]   
:Arguments: {fname,ts,tseg,psize,tangle}                   
:ArgumentTypes: {String,Real,Integer,Real,Real}            
:ReturnType: Manual                                        
:End:

/*:175*//*177:*/
#line 2638 "F:\Develop\mview3d\mathview3d.w"

/*153:*/
#line 2494 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
  MViewPoolSize::usage="MViewPoolSize returns the pool size of mathview3d."

/*:153*//*155:*/
#line 2507 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVPutGraphics3D::usage="MVPutGraphics3D[lst] is internal used."

/*:155*//*157:*/
#line 2519 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVClear::usage="MVClear[] clears the mathview3d window."

/*:157*//*159:*/
#line 2531 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVReset::usage="MVReset[] reset the view parameter in the mathview3d window."

/*:159*//*161:*/
#line 2543 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVShowWindow::usage="MVShowWindow[] show the mathview3d window if it was hidden."

/*:161*//*163:*/
#line 2555 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVHideWindow::usage="MVHideWindow[] hides the mathview3d window."

/*:163*//*165:*/
#line 2567 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVIconifyWindow::usage="MVIconifyWindow[] iconifys the mathview3d window."

/*:165*//*167:*/
#line 2579 "F:\Develop\mview3d\mathview3d.w"



/*:167*//*169:*/
#line 2591 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVZoom::usage="MVZoom[value] zooms in (value<1) or out (value>1)."

/*:169*//*172:*/
#line 2608 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVSpin::usage="MVSpin[angle,axis] starts spinning of the object
  in the mathview3d window around the axis {x,y,z} with angle increment angle."

/*:172*//*174:*/
#line 2622 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:mvWritePOVRay::usage="mvWritePOVRay[] is used internaly by mathview3d."

/*:174*//*176:*/
#line 2635 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:mvWriteDXF::usage="mvWriteDXF[] is used internaly by mathview3d."

/*:176*/
#line 2639 "F:\Develop\mview3d\mathview3d.w"


:Evaluate:
  Print["MathView3D installed, Version 1.1\\[NewLine]",
        "for ",$OperatingSystem," system ", $System,"\\[NewLine]",
        "\\[Copyright] by Jens-Peer Kuska 1997\\[NewLine]",
        "see: c't magazin f\\[UDoubleDot]r computer technik 9, 1997"];

:Evaluate:Unprotect["MathView3D`*"];

:Evaluate:
   BeginPackage["MathView3D`"]  

/*179:*/
#line 2673 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: MVClose::usage="MVClose[] will uninstall the mathview3d program."

/*:179*//*182:*/
#line 2755 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
   MVShow3D::usage=
     "MVShow3D[graph3d, opt...] will transfer a Graphics3D
      object to mathview3d."
:Evaluate:
   MVLineTubeSize::usage="MVLineTubeSize is an option for MVShow3D
   and MVWritePOVRay. The number given determines the absolute radius
   of the tubes arround lines."
:Evaluate:
   MVTubeSegments::usage="MVTubeSegments is an option for MVShow3D
   and MVWritePOVRay. The integer determines the number of segments
   for the tube approximation."
:Evaluate:
   MVTubeAngle::usage="MVTubeAngle is an option for MVShow3D
   and MVWritePOVRay. The angle (in degree) is used to determine if
   continued lines can smoothly continued with tubes."
:Evaluate:
   MVPointSphereSize::usage="MVPointSphereSize is an option for MVShow3D
   and MVWritePOVRay. The number gives the absolute size of spheres
   for point drawing."
:Evaluate:
   MVPolygonShading::usage="MVPolygonShading is an option for MVShow3D
   and MVWritePOVRay. The values MVSmooth (default), MVFlat and
   MVWireFrame are possible."
:Evaluate:
   MVSmooth::usage="MVSmooth is a value for MVPolygonShading."
:Evaluate:
   MVFlat::usage="MVFlat is a value for MVPolygonShading."
:Evaluate:
   MVWireFrame::usage="MVWireFrame is a value for MVPolygonShading."



/*:182*//*187:*/
#line 2848 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
  MVWritePOVRay::usage="MVWritePOVRay[fname, opt..] writes the current
   object in the mathview3d window to the POVRay 3.0 input file fname.
   MVWritePOVRay[fname, graph3d, opt..] transfers the Graphics3D graph3d
   to mathview3d and savs it as a POVRay file."

/*:187*//*188:*/
#line 2855 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
  MVWriteDXF::usage="MVWriteDXF[fname,opt..] writes the current object
    in the mathview3d window to a DXF file fname.\n
    MVWriteDXF[fname,graph3d,opt..] transfer the Graphics3D to mathview3d 
    and save a DXF file. Lines will only exported as as tubes, points as 
    spheres."

/*:188*//*195:*/
#line 3065 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVCreatePalette::usage=
  "MVCreatePalette[] will create a Mathematica 3.0 palette for mathview3d."

/*:195*/
#line 2652 "F:\Develop\mview3d\mathview3d.w"


:Evaluate: Begin["`Private`"]
:Evaluate: SetAttributes[MVShow3D,ReadProtected]
:Evaluate: SetAttributes[MVWritePOVRay,ReadProtected]
:Evaluate: SetAttributes[MVWriteDXF,ReadProtected]
:Evaluate: SetAttributes[MVClose,ReadProtected]
:Evaluate: SetAttributes[MVCreatePalette,ReadProtected]

/*178:*/
#line 2669 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVClose[]:= Uninstall /@                                
            Select[Links[],StringMatchQ[First[#],"*mathview3d*"] &]

/*:178*//*180:*/
#line 2678 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
   Options[MVShow3D]:={MVLineTubeSize->0.01,               
             MVTubeSegments->12,                           
             MVTubeAngle->30,                              
               MVPointSphereSize-> 0.01,                     
               MVPolygonShading -> MVSmooth}                 

:Evaluate:
   mvShade={MVSmooth,MVFlat,MVWireFrame}                 

:Evaluate:
   mvShadeID[a_]:=Switch[a,                                        
            MVSmooth,       1,                               
            MVFlat,         2,                               
            MVWireFrame,    3,                               
            _,              1]                               


/*:180*//*181:*/
#line 2697 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
   MVShow3D[surf_SurfaceGraphics,opt___]:=                     
    MVShow3D[Graphics3D[surf],opt]                             
:Evaluate:
  MVShow3D::noint="MVTubeSegments must be an integer."
:Evaluate:
  MVShow3D::noreal="`1` must be a number."

:Evaluate:
   MVShow3D[gr_Graphics3D,opt___]:=                                
  Module[{vp,pltrange,light,lpos,lcol,a,col,                       
              ambient,ltube,psize,shade,args,tseg,tangle},         
    {pltrange,vp,light,ambient}=                                   
           FullOptions[gr,#] & /@                                 
              {PlotRange,ViewPoint,LightSources,AmbientLight} /.   
         GrayLevel[x_] :> RGBColor[x,x,x];                 
    pltrange=Partition[Flatten[Transpose[pltrange]],3];        
    {lpos,lcol}=                                               
           Partition[Flatten[Transpose[light] /.                   
             RGBColor[args__] :> List[args],1],                    
             Length[light]];                                       
    ltube=MVLineTubeSize /. {opt} /.Options[MVShow3D];           
   If[!NumericQ[ltube],
     Message[MVShow3D::noreal,"MVLineTubeSize"];
     Return[$Failed];
    ];
   tangle=MVTubeAngle /. {opt} /. Options[MVShow3D];
   If[!NumericQ[tangle],
     Message[MVShow3D::noreal,"MVTubeAngle"];
     Return[$Failed];
    ];
    psize=MVPointSphereSize /. {opt} /.Options[MVShow3D];        
   If[!NumericQ[psize],
     Message[MVShow3D::noreal,"MVPointSphereSize"];
     Return[$Failed];
    ];
    shade=MVPolygonShading /. {opt}/.Options[MVShow3D];        
    shade=mvShadeID[shade];                                    
   tseg=MVTubeSegments /. {opt} /. Options[MVShow3D];          
    args=N[{                                                   
                pltrange,vp,                                   
                Flatten[lpos],Flatten[lcol],                   
                List @@ ambient,psize,                       
                ltube,                                         
                tangle} ] //. 0 ->0.0;                         
    AppendTo[args,shade];                                      
   AppendTo[args,tseg];                                        
    AppendTo[args,Flatten[N[{First[gr]}] //. 0 ->0.0] //.       
      { SurfaceColor[col_,__] :>  SurfaceColor[col],           
        Thickness[___] :> Sequence[],                          
        GrayLevel[a_]:> RGBColor[a,a,a],                       
        EdgeForm[___]:> Sequence[],                            
        Hue[__]:> Sequence[],                                  
        FaceForm[___]:> Sequence[]}];                          
     Global`MVPutGraphics3D[args]                              
   ]                                                           

/*:181*//*184:*/
#line 2793 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: Options[MVWritePOVRay]:=Options[MVShow3D]               
:Evaluate: MVWritePOVRay::noint="MVTubeSegments must be an integer." 

:Evaluate: MVWritePOVRay::noreal="`1` must be a real number."

/*:184*//*185:*/
#line 2803 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: MVWritePOVRay[fname_String,opts___Rule]:=          
              Module[{smth,ts,tseg,psize,tangle,filename},            
                 smth= MVPolygonShading /. {opts} /.              
                       Options[MVWritePOVRay];                
                 smth=mvShadeID[smth];                          
                 {ts,psize,tangle}=                                    
                 {MVLineTubeSize,MVPointSphereSize,MVTubeAngle}/. 
                    {opts} /.   
                   Options[MVWritePOVRay] // N /. 0 ->0.0;    
                If[!NumericQ[ts],
                  Message[MVWritePOVRay::noreal,"MVLineTubeSize"];
                  Return[$Failed];
                 ];
                If[!NumericQ[psize],
                  Message[MVWritePOVRay::noreal,"MVPointSphereSize"];
                  Return[$Failed];
                 ];
               tseg=MVTubeSegments /. {opts} /.                
                   Options[MVWritePOVRay];                    
                  If[! IntegerQ[tseg] ,                         
                    Message[MVWritePOVRay::noint];              
                     Return[$Failed]                             
                    ];                                           
                If[!NumericQ[tangle],
                  Message[MVWritePOVRay::noreal,"MVTubeAngle"];
                  Return[$Failed];
                 ];
                filename=StringReplace[                       
                           fname,                             
                           "/"->$PathnameSeparator];          
                  Global`mvWritePOVRay[filename,smth,ts,tseg,psize,tangle]    
                 ]                                              

/*:185*//*186:*/
#line 2839 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: MVWritePOVRay[fname_String,                        
                         gr_ /;                               
                         Head[gr]==Graphics3D ||              
                         Head[gr]==SurfaceGraphics,           
                         opts___Rule]:=                       
              (Global`MVClear[];MVShow3D[gr,opts];             
                MVWritePOVRay[fname,opts])                    

/*:186*//*189:*/
#line 2864 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:Options[MVWriteDXF]:={MVLineTubeSize->0.01,
		MVTubeSegments->12,                              
		MVPointSphereSize->0.01,                         
		MVTubeAngle->30.}                                

/*:189*//*190:*/
#line 2870 "F:\Develop\mview3d\mathview3d.w"

:Evaluate: MVWriteDXF::noreal="`1` must be a floating point number"

/*:190*//*191:*/
#line 2874 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVWriteDXF[fname_String,opt___?OptionQ]:=                
	  Module[{ts,tseg,psize,tangle,filename},                        
			ts=MVLineTubeSize /. {opt} /. Options[MVWriteDXF];           
			tseg=MVTubeSegments /. {opt} /. Options[MVWriteDXF];         
			psize=MVPointSphereSize /. {opt} /. Options[MVWriteDXF];     
			tangle=MVTubeAngle /. {opt} /. Options[MVWriteDXF];          
			{ts,psize,tangle}=N[{ts,psize,tangle}] /. 0-> 0.0;           
			If[!IntegerQ[tseg],                                          
				 Message[MVShow3D::noint,"MVTubeSegments"];                
				Return[$Failed];                                           
				];                                                         
			If[!NumericQ[ts],                                            
				  Message[MVWriteDXF::noreal,"MVLineTubeSize"];            
				Return[$Failed];                                           
				];                                                         
			If[!NumericQ[psize],                                         
				Message[MVWriteDXF::noreal,"MVPointSphereSize"];           
				Return[$Failed];                                           
				];                                                         
			If[!NumericQ[tangle],                                        
				Message[MVWriteDXF::noreal,"MVTubeAngle"];                 
				Return[$Failed];                                           
				];                                                         
			filename=StringReplace[fname,"/" -> $PathnameSeparator];     
			Global`mvWriteDXF[filename,ts,tseg,psize,tangle]             
			]                                                            

/*:191*//*192:*/
#line 2903 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:MVWriteDXF[fname_String,                                 
	          gr_ /;                                                 
	            Head[gr]==Graphics3D ||                              
	            Head[gr]==SurfaceGraphics,                           
	            opts___?OptionQ]:=                                   
	          (Global`MVClear[];                                     
	           MVShow3D[gr,opts];MVWriteDXF[fname,opts])             

/*:192*//*194:*/
#line 2913 "F:\Develop\mview3d\mathview3d.w"

:Evaluate:
  mvPaletteHead =                              
   {                                           
    FrameBox[StyleBox[RowBox[{"Actions"}]]],   
    FrameBox[StyleBox[RowBox[{"Main"}   ]]],   
    FrameBox[StyleBox[RowBox[{"Spin"}   ]]],   
    FrameBox[StyleBox[RowBox[{"Window"} ]]]    
   };                                          
:Evaluate:
  mvShowButton = ButtonBox[                                       
                 StyleBox[
                   RowBox[{"MVShow3D","[","\\[Placeholder]","]"}]],
                 ButtonData :>                                    
                   BoxData[                                       
                     RowBox[{"MVShow3D","[","\[Placeholder]",",", 
                     "MVLineTubeSize","->","0.01",",",       
                     "MVPolygonShading","->","MVSmooth",",", 
                     "MVTubeSegments","->","12",",",         
                     "MVTubeAngle","->","30",",",            
                     "MVPointSphereSize","->","0.01","]"}]   
                  ]                                               
                ];                                                
:Evaluate:
  mvSPOVButton = ButtonBox[                                               
               StyleBox[
                 RowBox[{"Smooth"," ","MVWritePOVRay","[","\\[Placeholder]","]"}]], 
               ButtonData :>                                              
                 BoxData[                                                 
                   RowBox[{"MVWritePOVRay", "[", "\\[Placeholder]",",",    
                           "PolygonShading", "->", "MVSmooth", "]"}]]];
:Evaluate:
  mvFPOVButton = ButtonBox[                                               
               StyleBox[
                 RowBox[{"Flat"," ","MVWritePOVray","[","\\[Placeholder]","]"}]],
               ButtonData :>                                              
                 BoxData[                                                 
                   RowBox[{"MVWritePOVRay", "[", "\\[Placeholder]", ",",   
                           "PolygonShading", "->", "MVFlat", "]"}]]];


:Evaluate:                                                
  mvClearButton = ButtonBox[                              
                StyleBox[                                 
                  RowBox[{"Clear", " ", "Window"}]],      
                  ButtonFunction :> Global`MVClear[],     
                  ButtonEvaluator -> Automatic];          

:Evaluate:                                                
  mvResetButton = ButtonBox[                              
                StyleBox[RowBox[{"Reset", " ", "view"}]], 
                ButtonFunction :> Global`MVReset[],       
                ButtonEvaluator -> Automatic];            

:Evaluate:                                                
  mvZoomInButton = ButtonBox[                             
                 StyleBox[RowBox[{"Zoom", " ",  "in"}]],  
                 ButtonFunction :> Global`MVZoom[0.5],    
                 ButtonEvaluator -> Automatic];           

:Evaluate:                                                
  mvZoomOutButton = ButtonBox[                            
                  StyleBox[RowBox[{"Zoom", " ", "out"}]], 
                  ButtonFunction :> Global`MVZoom[2.0],   
                  ButtonEvaluator -> Automatic];          

:Evaluate:                                                
  mvSpinXButton =  ButtonBox[                             
                 StyleBox[RowBox[{"X-axis"}]],            
                 ButtonFunction:> Global`MVSpin[N[Pi/10],{1.0,0.0,0.0}],
                 ButtonEvaluator->Automatic];                    

:Evaluate:                                                       
  mvSpinYButton=ButtonBox[                                       
              StyleBox[RowBox[{"Y-axis"}]],                      
              ButtonFunction:> Global`MVSpin[N[Pi/10],{0.0,1.0,0.0}],   
              ButtonEvaluator->Automatic];                       
:Evaluate:                                                       
  mvSpinZButton= ButtonBox[                                      
               StyleBox[RowBox[{"Z-axis"}]],                     
               ButtonFunction :>  Global`MVSpin[N[Pi/10], {0.0, 0.0, 1.0}],
               ButtonEvaluator -> Automatic];
:Evaluate:                                   
  mvSpinHaltButton =                         
    ButtonBox[                               
      StyleBox[RowBox[{"Stop"}]],            
      ButtonFunction :>  Global`MVStopSpin[],       
      ButtonEvaluator -> Automatic];         
:Evaluate:                                   
  mvHideWindowButton =                     
    ButtonBox[                             
      StyleBox[RowBox[{"Hide"}]],          
      ButtonFunction :>  Global`MVHideWindow[],   
      ButtonEvaluator -> Automatic];       
:Evaluate:                                 
  mvShowWindowButton =                     
    ButtonBox[                             
      StyleBox[RowBox[{"Show"}]],          
      ButtonFunction :>  Global`MVShowWindow[],   
      ButtonEvaluator -> Automatic];       
:Evaluate:                                 
  mvIconifyButton =                        
    ButtonBox[                             
      StyleBox[RowBox[{"Iconify"}]],       
      ButtonFunction :>  Global`MVIconifyWindow[],
      ButtonEvaluator -> Automatic];       
:Evaluate:                                 
  mvQuitButton =                           
    ButtonBox[                             
      StyleBox[RowBox[{"Quit"}]],          
      ButtonFunction :>  MVClose[],        
      ButtonEvaluator -> Automatic];       
:Evaluate:
  MVCreatePalette[] :=                                   
    Module[{pal},                                        
    pal = Cell[                                          
            BoxData[                                     
              GridBox[                                   
                {                                        
                  { " ", StyleBox[                       
                           RowBox[{"OpenGL",  "Viewer"}],
                           FontFamily -> "Helvetica"     
                          ], " "," "},                   
                 mvPaletteHead,                          
                 {mvShowButton, mvClearButton, mvSpinXButton, mvShowWindowButton},
                 {mvSPOVButton, mvResetButton, mvSpinYButton, mvHideWindowButton},
                 {mvFPOVButton, mvZoomInButton, mvSpinZButton, mvIconifyButton},  
                 {FrameBox[                                                       
                    StyleBox[                                                     
                      RowBox[{"\\[Copyright]", " ", "1997",
                            " ", "by", " ",  "Jens-Peer", 
                            " ", "Kuska"}                 
                       ]                                  
                     ]                                    
                   ],                                     
                   mvZoomOutButton, mvSpinHaltButton, mvQuitButton}},
                 RowSpacings -> 0,                                   
                 ColumnSpacings -> 0,                                
                 Global`GridDefaultElement :>    
                   ButtonBox[ "\[Placeholder]"]  
                ]                                                    
             ],   (* BoxData *)
            "Input",           
            Active -> True,    
            CellFrame -> False 
           ];  (* Cell *)      
        FrontEndExecute[       
          {FrontEnd`NotebookApply[FrontEnd`InputNotebook[], pal]}
         ]                                                       
       ]                                                         


/*:194*/
#line 2661 "F:\Develop\mview3d\mathview3d.w"


:Evaluate: End[] (* Private *)

:Evaluate: EndPackage[]
:Evaluate: Protect["MathView3D`*"]

/*:177*/
#line 51 "F:\Develop\mview3d\mathview3d.w"



/*:1*/
